unit FrmStore;

{

   COPYRIGHT 1999 .. 2014 Blue Hell / Jan Punter

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 2 as
  published by the Free Software Foundation;

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  For all listed email addresses :

    _dot. to be substituted by a dot      '.'
    2@t2  to be substituted by an at sign '@'


  Blue Hell is a trade mark owned by

    Jan Punter
    Oogstplein 6
    7545 HP Enschede
    the Netherlands
    http://www.iaf.nl/Users/BlueHell/
    http://bluehell.electro-music.com/
    j_dot.punter2@t2iaf_dot.nl

  All rights attributed to Blue Hell are owned by Jan Punter.
}

interface

uses

  WinApi.Windows, WinApi.Messages, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.Buttons, Vcl.Imaging.jpeg, Vcl.ImgList, Vcl.Samples.Spin,
  Vcl.Imaging.pngimage,

  knobs2013;

type

  TOnDesignerLog = procedure( const aSender: TObject; const aMsg: string) of object;

  TFormStore = class(TForm)
    ImageAdder: TImage;
    ImageAmplifier: TImage;
    ImageGate: TImage;
    ImageAudioIn: TImage;
    ImageAudioOut: TImage;
    ImageAverage: TImage;
    ImageConstant: TImage;
    ImageDFlipFlop: TImage;
    ImageDelay: TImage;
    ImageDisplay: TImage;
    ImageDivider: TImage;
    ImageEnvADSR: TImage;
    ImageEnvAHD: TImage;
    ImageEnvAR: TImage;
    ImageEnvARRetrig: TImage;
    ImageHrastOsc: TImage;
    ImageInverter: TImage;
    ImageLfo: TImage;
    ImageLfoTrig: TImage;
    ImageMidiCCIn: TImage;
    ImageMidiCCOut: TImage;
    ImageMidiNoteIn: TImage;
    ImageMidiNoteOut: TImage;
    ImageMinMax: TImage;
    ImageMixM4to1: TImage;
    ImageMixM6to6: TImage;
    ImageMixS2to1: TImage;
    ImageMultiplier: TImage;
    ImageNoise: TImage;
    ImageNoiseLfo: TImage;
    ImageNoiseLfoTrig: TImage;
    ImageNoiseTrig: TImage;
    ImageNot: TImage;
    ImageNotes: TImage;
    ImagePan: TImage;
    ImagePanel1: TImage;
    ImagePanel2: TImage;
    ImagePanel3: TImage;
    ImagePanel4: TImage;
    ImagePanel5: TImage;
    ImageQuantizer: TImage;
    ImageRSFlipFlop: TImage;
    ImageRandomWalkLfo: TImage;
    ImageRatio: TImage;
    ImageRectifier: TImage;
    ImageRotator: TImage;
    ImageSVF: TImage;
    ImageSampleAndHold: TImage;
    ImageScaler: TImage;
    ImageSeqClockStep: TImage;
    ImageSeqStep: TImage;
    ImageSequencer: TImage;
    ImageOsc: TImage;
    ImageOscTrig: TImage;
    ImageSquare: TImage;
    ImageSquareLfo: TImage;
    ImageSquareLfoTrig: TImage;
    ImageSquareTrig: TImage;
    ImageSwitch2to1: TImage;
    ImageTextSequencer: TImage;
    ImageTrackAndHold: TImage;
    ImageXFade: TImage;
    MemoAdder: TMemo;
    MemoAmplifier: TMemo;
    MemoGate: TMemo;
    MemoAudioIn: TMemo;
    MemoAudioOut: TMemo;
    MemoAverage: TMemo;
    MemoConstant: TMemo;
    MemoDFlipFlop: TMemo;
    MemoDelay: TMemo;
    MemoDisplay: TMemo;
    MemoDivider: TMemo;
    MemoEnvADSR: TMemo;
    MemoEnvAHD: TMemo;
    MemoEnvAR: TMemo;
    MemoEnvARRetrig: TMemo;
    MemoHrastOsc: TMemo;
    MemoInverter: TMemo;
    MemoLfo: TMemo;
    MemoLfoTrig: TMemo;
    MemoMidiCCIn: TMemo;
    MemoMidiCCOut: TMemo;
    MemoMidiNoteIn: TMemo;
    MemoMidiNoteOut: TMemo;
    MemoMinMax: TMemo;
    MemoMixM4to1: TMemo;
    MemoMixM6to6: TMemo;
    MemoMixS2to1: TMemo;
    MemoMultiplier: TMemo;
    MemoNoise: TMemo;
    MemoNoiseLfo: TMemo;
    MemoNoiseLfoTrig: TMemo;
    MemoNoiseTrig: TMemo;
    MemoNot: TMemo;
    MemoNotes: TMemo;
    MemoPan: TMemo;
    MemoPanel1: TMemo;
    MemoPanel2: TMemo;
    MemoPanel3: TMemo;
    MemoPanel4: TMemo;
    MemoPanel5: TMemo;
    MemoQuantizer: TMemo;
    MemoRSFlipFlop: TMemo;
    MemoRandomWalkLfo: TMemo;
    MemoRatio: TMemo;
    MemoRectifier: TMemo;
    MemoRotator: TMemo;
    MemoSVF: TMemo;
    MemoSampleAndHold: TMemo;
    MemoScaler: TMemo;
    MemoSeqClockStep: TMemo;
    MemoSeqStep: TMemo;
    MemoSequencer: TMemo;
    MemoOsc: TMemo;
    MemoOscTrig: TMemo;
    MemoSquare: TMemo;
    MemoSquareLfo: TMemo;
    MemoSquareLfoTrig: TMemo;
    MemoSquareTrig: TMemo;
    MemoSwitch2to1: TMemo;
    MemoTextSequencer: TMemo;
    MemoTrackAndHold: TMemo;
    MemoXFade: TMemo;
    adder: TKnobsModule;
    adder_editlabel: TKnobsEditLabel;
    adder_in1: TKnobsInput;
    adder_in2: TKnobsInput;
    adder_in3: TKnobsInput;
    adder_in4: TKnobsInput;
    adder_mute: TKnobsSelector;
    adder_out: TKnobsOutput;
    amplifier: TKnobsModule;
    amplifier_display_gain: TKnobsDisplay;
    amplifier_editlabel: TKnobsEditLabel;
    amplifier_gain: TKnobsSmallKnob;
    amplifier_in1: TKnobsInput;
    amplifier_in2: TKnobsInput;
    amplifier_in3: TKnobsInput;
    amplifier_in4: TKnobsInput;
    amplifier_mute: TKnobsSelector;
    amplifier_out1: TKnobsOutput;
    amplifier_out2: TKnobsOutput;
    amplifier_out3: TKnobsOutput;
    amplifier_out4: TKnobsOutput;
    audioin: TKnobsModule;
    audioin_editlabel: TKnobsEditLabel;
    audioin_out1: TKnobsOutput;
    audioin_out2: TKnobsOutput;
    audioin_textlabel_l_out1: TKnobsTextLabel;
    audioin_textlabel_r_out1: TKnobsTextLabel;
    audioout: TKnobsModule;
    audioout_editlabel: TKnobsEditLabel;
    audioout_in1: TKnobsInput;
    audioout_in2: TKnobsInput;
    audioout_textlabel_l_in1: TKnobsTextLabel;
    audioout_textlabel_r_in1: TKnobsTextLabel;
    avg: TKnobsModule;
    avg_alpha: TKnobsSmallKnob;
    avg_editlabel: TKnobsEditLabel;
    avg_hp: TKnobsOutput;
    avg_in: TKnobsInput;
    avg_lp: TKnobsOutput;
    avg_textlabel_in: TKnobsTextLabel;
    avg_textlabel_invout: TKnobsTextLabel;
    avg_textlabel_out: TKnobsTextLabel;
    constant: TKnobsModule;
    constant_display_value: TKnobsDisplay;
    constant_editlabel: TKnobsEditLabel;
    constant_mute: TKnobsSelector;
    constant_out: TKnobsOutput;
    constant_value: TKnobsSmallKnob;
    delay: TKnobsModule;
    delay_delay: TKnobsInput;
    delay_display_length: TKnobsDisplay;
    delay_editlabel: TKnobsEditLabel;
    delay_in: TKnobsInput;
    delay_length: TKnobsSmallKnob;
    delay_out: TKnobsOutput;
    delay_outfixed: TKnobsOutput;
    delay_range: TKnobsSelector;
    delay_tabseet: TTabSheet;
    delay_textlabel_delay: TKnobsTextLabel;
    delay_textlabel_fixed: TKnobsTextLabel;
    delay_textlabel_in: TKnobsTextLabel;
    delay_textlabel_maxdelay: TKnobsTextLabel;
    dflipflop: TKnobsModule;
    dflipflop_clk: TKnobsInput;
    dflipflop_d: TKnobsInput;
    dflipflop_editlabel: TKnobsEditLabel;
    dflipflop_image: TImage;
    dflipflop_indicator_notq: TKnobsIndicator;
    dflipflop_indicator_q: TKnobsIndicator;
    dflipflop_notq: TKnobsOutput;
    dflipflop_q: TKnobsOutput;
    display: TKnobsModule;
    display_editlabel: TKnobsEditLabel;
    display_in1: TKnobsInput;
    display_in2: TKnobsInput;
    display_knobsbox_left: TKnobsBox;
    display_knobsbox_right: TKnobsBox;
    display_level1: TKnobsIndicatorBar;
    display_level2: TKnobsIndicatorBar;
    display_mode: TKnobsSelector;
    display_textlabel_db: TKnobsTextLabel;
    divider: TKnobsModule;
    divider_count: TKnobsSmallKnob;
    divider_display_count: TKnobsDisplay;
    divider_editlabel: TKnobsEditLabel;
    divider_indicator_out: TKnobsIndicator;
    divider_out: TKnobsOutput;
    divider_symbol_trig: TImage;
    divider_textlabel_trig: TKnobsTextLabel;
    divider_trig: TKnobsInput;
    envadsr: TKnobsModule;
    envadsr_ashape: TKnobsSelector;
    envadsr_attack: TKnobsSmallKnob;
    envadsr_decay: TKnobsSmallKnob;
    envadsr_display_attack: TKnobsDisplay;
    envadsr_display_decay: TKnobsDisplay;
    envadsr_display_release: TKnobsDisplay;
    envadsr_display_sustain: TKnobsDisplay;
    envadsr_dshape: TKnobsSelector;
    envadsr_editlabel: TKnobsEditLabel;
    envadsr_gain: TKnobsInput;
    envadsr_indicator_trig: TKnobsIndicator;
    envadsr_mode: TKnobsSelector;
    envadsr_mute: TKnobsSelector;
    envadsr_out: TKnobsOutput;
    envadsr_arange: TKnobsSelector;
    envadsr_release: TKnobsSmallKnob;
    envadsr_rshape: TKnobsSelector;
    envadsr_sigin: TKnobsInput;
    envadsr_sigout: TKnobsOutput;
    envadsr_sustain: TKnobsSmallKnob;
    envadsr_symbol_connect: TImage;
    envadsr_symbol_trig: TImage;
    envadsr_textlabel_attack: TKnobsTextLabel;
    envadsr_textlabel_decay: TKnobsTextLabel;
    envadsr_textlabel_env: TKnobsTextLabel;
    envadsr_textlabel_gain: TKnobsTextLabel;
    envadsr_textlabel_release: TKnobsTextLabel;
    envadsr_textlabel_sustain: TKnobsTextLabel;
    envadsr_trig: TKnobsInput;
    envadsr_viewer: TKnobsDataViewer;
    envahd: TKnobsModule;
    envahd_ashape: TKnobsSelector;
    envahd_attack: TKnobsSmallKnob;
    envahd_decay: TKnobsSmallKnob;
    envahd_display_attack: TKnobsDisplay;
    envahd_display_decay: TKnobsDisplay;
    envahd_display_hold: TKnobsDisplay;
    envahd_dshape: TKnobsSelector;
    envahd_editlabel: TKnobsEditLabel;
    envahd_gain: TKnobsInput;
    envahd_hold: TKnobsSmallKnob;
    envahd_indicator_trig: TKnobsIndicator;
    envahd_mode: TKnobsSelector;
    envahd_mute: TKnobsSelector;
    envahd_out: TKnobsOutput;
    envahd_arange: TKnobsSelector;
    envahd_sigin: TKnobsInput;
    envahd_sigout: TKnobsOutput;
    envahd_symbol_connect: TImage;
    envahd_symbol_trig: TImage;
    envahd_textlabel_attack: TKnobsTextLabel;
    envahd_textlabel_decay: TKnobsTextLabel;
    envahd_textlabel_env: TKnobsTextLabel;
    envahd_textlabel_gain: TKnobsTextLabel;
    envahd_textlabel_hold: TKnobsTextLabel;
    envahd_trig: TKnobsInput;
    envahd_viewer: TKnobsDataViewer;
    envar: TKnobsModule;
    envar_attack: TKnobsSmallKnob;
    envar_display_attack: TKnobsDisplay;
    envar_display_release: TKnobsDisplay;
    envar_editlabel: TKnobsEditLabel;
    envar_gain: TKnobsInput;
    envar_indicator_trig: TKnobsIndicator;
    envar_mute: TKnobsSelector;
    envar_out: TKnobsOutput;
    envar_release: TKnobsSmallKnob;
    envar_sigin: TKnobsInput;
    envar_sigout: TKnobsOutput;
    envar_symbol_connect: TImage;
    envar_textlabel_attack: TKnobsTextLabel;
    envar_textlabel_gain: TKnobsTextLabel;
    envar_textlabel_release: TKnobsTextLabel;
    envar_textlabel_trig: TKnobsTextLabel;
    envar_trig: TKnobsInput;
    envarretrig: TKnobsModule;
    envarretrig_attack: TKnobsSmallKnob;
    envarretrig_display_attack: TKnobsDisplay;
    envarretrig_display_release: TKnobsDisplay;
    envarretrig_editlabel: TKnobsEditLabel;
    envarretrig_gain: TKnobsInput;
    envarretrig_indicator_trig: TKnobsIndicator;
    envarretrig_mute: TKnobsSelector;
    envarretrig_out: TKnobsOutput;
    envarretrig_release: TKnobsSmallKnob;
    envarretrig_sigin: TKnobsInput;
    envarretrig_sigout: TKnobsOutput;
    envarretrig_symbol_connect: TImage;
    envarretrig_symbol_trig: TImage;
    envarretrig_textlabel_attack: TKnobsTextLabel;
    envarretrig_textlabel_gain: TKnobsTextLabel;
    envarretrig_textlabel_release: TKnobsTextLabel;
    envarretrig_textlabel_trig: TKnobsTextLabel;
    envarretrig_trig: TKnobsInput;
    envelope_tabsheet: TTabSheet;
    filter_tabsheet: TTabSheet;
    gate: TKnobsModule;
    gate_editlabel: TKnobsEditLabel;
    gate_function: TKnobsSelector;
    gate_in1: TKnobsInput;
    gate_in2: TKnobsInput;
    gate_in3: TKnobsInput;
    gate_in4: TKnobsInput;
    gate_indicator_out: TKnobsIndicator;
    gate_out: TKnobsOutput;
    hrastOscLabelSync: TKnobsTextLabel;
    hrastOsc_FMInput: TKnobsInput;
    hrastOsc_PMInput: TKnobsInput;
    hrastOsc_PWMInput: TKnobsInput;
    hrastosc: TKnobsModule;
    hrastosc_Bandlimit: TKnobsSmallKnob;
    hrastosc_FM: TKnobsSmallKnob;
    hrastosc_Freq: TKnobsSmallKnob;
    hrastosc_Level: TKnobsSmallKnob;
    hrastosc_Morph: TKnobsSmallKnob;
    hrastosc_Mute: TKnobsSelector;
    hrastosc_Output: TKnobsOutput;
    hrastosc_PM: TKnobsSmallKnob;
    hrastosc_PW: TKnobsSmallKnob;
    hrastosc_PWM: TKnobsSmallKnob;
    hrastosc_Shape: TKnobsSmallKnob;
    hrastosc_SyncInput: TKnobsInput;
    hrastosc_Vintage: TKnobsSelector;
    hrastosc_display_freq: TKnobsDisplay;
    hrastosc_symbol_sync: TImage;
    hrastosc_textlabel_FM: TKnobsTextLabel;
    hrastosc_textlabel_bandlimit: TKnobsTextLabel;
    hrastosc_textlabel_editlabel: TKnobsEditLabel;
    hrastosc_textlabel_level: TKnobsTextLabel;
    hrastosc_textlabel_morph: TKnobsTextLabel;
    hrastosc_textlabel_pm: TKnobsTextLabel;
    hrastosc_textlabel_pw: TKnobsTextLabel;
    hrastosc_textlabel_pwm: TKnobsTextLabel;
    hrastosc_textlabel_shape: TKnobsTextLabel;
    inout_tabsheet: TTabSheet;
    inverter: TKnobsModule;
    inverter_editlabel: TKnobsEditLabel;
    inverter_in1: TKnobsInput;
    inverter_in2: TKnobsInput;
    inverter_in3: TKnobsInput;
    inverter_in4: TKnobsInput;
    inverter_out1: TKnobsOutput;
    inverter_out2: TKnobsOutput;
    inverter_out3: TKnobsOutput;
    inverter_out4: TKnobsOutput;
    lfo: TKnobsModule;
    lfo_display_frequency: TKnobsDisplay;
    lfo_editlabel: TKnobsEditLabel;
    lfo_fm: TKnobsInput;
    lfo_fmlevel: TKnobsSmallKnob;
    lfo_frequency: TKnobsSmallKnob;
    lfo_indicator_out: TKnobsIndicator;
    lfo_indicator_res: TKnobsIndicator;
    lfo_mute: TKnobsSelector;
    lfo_out: TKnobsOutput;
    lfo_phase: TKnobsInput;
    lfo_pmlevel: TKnobsSmallKnob;
    lfo_range: TKnobsSelector;
    lfo_res: TKnobsInput;
    lfo_shape: TKnobsSelector;
    lfo_symbol_res: TImage;
    lfo_sync: TKnobsOutput;
    lfo_tabsheet: TTabSheet;
    lfo_textlabel_fm: TKnobsTextLabel;
    lfo_textlabel_out: TKnobsTextLabel;
    lfo_textlabel_phase: TKnobsTextLabel;
    lfo_textlabel_res: TKnobsTextLabel;
    lfo_textlabel_sync: TKnobsTextLabel;
    lfotrig: TKnobsModule;
    lfotrig_count: TKnobsNoKnob;
    lfotrig_display_count: TKnobsDisplay;
    lfotrig_display_frequency: TKnobsDisplay;
    lfotrig_editlabel: TKnobsEditLabel;
    lfotrig_fm: TKnobsInput;
    lfotrig_fmlevel: TKnobsSmallKnob;
    lfotrig_frequency: TKnobsSmallKnob;
    lfotrig_indicator_out: TKnobsIndicator;
    lfotrig_indicator_ready: TKnobsIndicator;
    lfotrig_indicator_trig: TKnobsIndicator;
    lfotrig_mute: TKnobsSelector;
    lfotrig_out: TKnobsOutput;
    lfotrig_range: TKnobsSelector;
    lfotrig_ready: TKnobsOutput;
    lfotrig_shape: TKnobsSelector;
    lfotrig_symbol_trig: TImage;
    lfotrig_textlabel_fm: TKnobsTextLabel;
    lfotrig_textlabel_out: TKnobsTextLabel;
    lfotrig_textlabel_ready: TKnobsTextLabel;
    lfotrig_textlabel_trig: TKnobsTextLabel;
    lfotrig_trig: TKnobsInput;
    logic_tabsheet: TTabSheet;
    logicnot: TKnobsModule;
    logicnot_editlabel: TKnobsEditLabel;
    logicnot_in1: TKnobsInput;
    logicnot_in2: TKnobsInput;
    logicnot_in3: TKnobsInput;
    logicnot_in4: TKnobsInput;
    logicnot_indicator_out1: TKnobsIndicator;
    logicnot_indicator_out2: TKnobsIndicator;
    logicnot_indicator_out3: TKnobsIndicator;
    logicnot_indicator_out4: TKnobsIndicator;
    logicnot_out1: TKnobsOutput;
    logicnot_out2: TKnobsOutput;
    logicnot_out3: TKnobsOutput;
    logicnot_out4: TKnobsOutput;
    midi_tabsheet: TTabSheet;
    midiccin: TKnobsModule;
    midiccin_cc: TKnobsNoKnob;
    midiccin_ch: TKnobsNoKnob;
    midiccin_display_cc: TKnobsDisplay;
    midiccin_display_ch: TKnobsDisplay;
    midiccin_editlabel: TKnobsEditLabel;
    midiccin_gate: TKnobsOutput;
    midiccin_indicator_gate: TKnobsIndicator;
    midiccin_textlabel_cc: TKnobsTextLabel;
    midiccin_textlabel_gate: TKnobsTextLabel;
    midiccin_textlabel_value: TKnobsTextLabel;
    midiccin_value: TKnobsOutput;
    midiccout: TKnobsModule;
    midiccout_cc: TKnobsNoKnob;
    midiccout_ch: TKnobsNoKnob;
    midiccout_display_cc: TKnobsDisplay;
    midiccout_display_ch: TKnobsDisplay;
    midiccout_editlabel: TKnobsEditLabel;
    midiccout_gate: TKnobsInput;
    midiccout_indicator_gate: TKnobsIndicator;
    midiccout_textlabel_cc: TKnobsTextLabel;
    midiccout_textlabel_gate: TKnobsTextLabel;
    midiccout_textlabel_value: TKnobsTextLabel;
    midiccout_value: TKnobsInput;
    midinotein: TKnobsModule;
    midinotein_ch: TKnobsNoKnob;
    midinotein_display_ch: TKnobsDisplay;
    midinotein_editlabel: TKnobsEditLabel;
    midinotein_gate: TKnobsOutput;
    midinotein_indicator_gate: TKnobsIndicator;
    midinotein_note: TKnobsOutput;
    midinotein_textlabel_gate: TKnobsTextLabel;
    midinotein_textlabel_note: TKnobsTextLabel;
    midinotein_textlabel_velocity: TKnobsTextLabel;
    midinotein_textlabel_veloff: TKnobsTextLabel;
    midinotein_textlabel_velon: TKnobsTextLabel;
    midinotein_veloff: TKnobsOutput;
    midinotein_velon: TKnobsOutput;
    midinoteout: TKnobsModule;
    midinoteout_ch: TKnobsNoKnob;
    midinoteout_display_ch: TKnobsDisplay;
    midinoteout_editlabel: TKnobsEditLabel;
    midinoteout_gate: TKnobsInput;
    midinoteout_indicator_gate: TKnobsIndicator;
    midinoteout_note: TKnobsInput;
    midinoteout_textlabel_gate: TKnobsTextLabel;
    midinoteout_textlabel_note: TKnobsTextLabel;
    midinoteout_textlabel_velocity: TKnobsTextLabel;
    midinoteout_textlabel_veloff: TKnobsTextLabel;
    midinoteout_textlabel_velon: TKnobsTextLabel;
    midinoteout_veloff: TKnobsInput;
    midinoteout_velon: TKnobsInput;
    minmax: TKnobsModule;
    minmax_editlabel: TKnobsEditLabel;
    minmax_in1: TKnobsInput;
    minmax_in2: TKnobsInput;
    minmax_max: TKnobsOutput;
    minmax_min: TKnobsOutput;
    minmax_textlabel_1in2: TKnobsTextLabel;
    minmax_textlabel_minmax: TKnobsTextLabel;
    mixer_tabsheet: TTabSheet;
    mixm4to1: TKnobsModule;
    mixm4to1_editlabel: TKnobsEditLabel;
    mixm4to1_in1: TKnobsInput;
    mixm4to1_in2: TKnobsInput;
    mixm4to1_in3: TKnobsInput;
    mixm4to1_in4: TKnobsInput;
    mixm4to1_in: TKnobsInput;
    mixm4to1_level1: TKnobsSmallKnob;
    mixm4to1_level2: TKnobsSmallKnob;
    mixm4to1_level3: TKnobsSmallKnob;
    mixm4to1_level4: TKnobsSmallKnob;
    mixm4to1_mute2: TKnobsSelector;
    mixm4to1_mute3: TKnobsSelector;
    mixm4to1_mute4: TKnobsSelector;
    mixm4to1_mute1: TKnobsSelector;
    mixm4to1_out: TKnobsOutput;
    mixm6to6: TKnobsModule;
    mixm6to6_box_inchains: TKnobsBox;
    mixm6to6_box_ins: TKnobsBox;
    mixm6to6_box_outchains: TKnobsBox;
    mixm6to6_box_outs: TKnobsBox;
    mixm6to6_editlabel: TKnobsEditLabel;
    mixm6to6_in1: TKnobsInput;
    mixm6to6_in2: TKnobsInput;
    mixm6to6_in3: TKnobsInput;
    mixm6to6_in4: TKnobsInput;
    mixm6to6_in5: TKnobsInput;
    mixm6to6_in6: TKnobsInput;
    mixm6to6_inchcol1: TKnobsInput;
    mixm6to6_inchcol2: TKnobsInput;
    mixm6to6_inchcol3: TKnobsInput;
    mixm6to6_inchcol4: TKnobsInput;
    mixm6to6_inchcol5: TKnobsInput;
    mixm6to6_inchcol6: TKnobsInput;
    mixm6to6_inr1c1: TKnobsInput;
    mixm6to6_inr1c2: TKnobsInput;
    mixm6to6_inr1c3: TKnobsInput;
    mixm6to6_inr1c4: TKnobsInput;
    mixm6to6_inr1c5: TKnobsInput;
    mixm6to6_inr1c6: TKnobsInput;
    mixm6to6_inr2c1: TKnobsInput;
    mixm6to6_inr2c2: TKnobsInput;
    mixm6to6_inr2c3: TKnobsInput;
    mixm6to6_inr2c4: TKnobsInput;
    mixm6to6_inr2c5: TKnobsInput;
    mixm6to6_inr2c6: TKnobsInput;
    mixm6to6_inr3c1: TKnobsInput;
    mixm6to6_inr3c2: TKnobsInput;
    mixm6to6_inr3c3: TKnobsInput;
    mixm6to6_inr3c4: TKnobsInput;
    mixm6to6_inr3c5: TKnobsInput;
    mixm6to6_inr3c6: TKnobsInput;
    mixm6to6_inr4c1: TKnobsInput;
    mixm6to6_inr4c2: TKnobsInput;
    mixm6to6_inr4c3: TKnobsInput;
    mixm6to6_inr4c4: TKnobsInput;
    mixm6to6_inr4c5: TKnobsInput;
    mixm6to6_inr4c6: TKnobsInput;
    mixm6to6_inr5c1: TKnobsInput;
    mixm6to6_inr5c2: TKnobsInput;
    mixm6to6_inr5c3: TKnobsInput;
    mixm6to6_inr5c4: TKnobsInput;
    mixm6to6_inr5c5: TKnobsInput;
    mixm6to6_inr5c6: TKnobsInput;
    mixm6to6_inr6c1: TKnobsInput;
    mixm6to6_inr6c2: TKnobsInput;
    mixm6to6_inr6c3: TKnobsInput;
    mixm6to6_inr6c4: TKnobsInput;
    mixm6to6_inr6c5: TKnobsInput;
    mixm6to6_inr6c6: TKnobsInput;
    mixm6to6_levelr1c1: TKnobsSmallKnob;
    mixm6to6_levelr1c2: TKnobsSmallKnob;
    mixm6to6_levelr1c3: TKnobsSmallKnob;
    mixm6to6_levelr1c4: TKnobsSmallKnob;
    mixm6to6_levelr1c5: TKnobsSmallKnob;
    mixm6to6_levelr1c6: TKnobsSmallKnob;
    mixm6to6_levelr2c1: TKnobsSmallKnob;
    mixm6to6_levelr2c2: TKnobsSmallKnob;
    mixm6to6_levelr2c3: TKnobsSmallKnob;
    mixm6to6_levelr2c4: TKnobsSmallKnob;
    mixm6to6_levelr2c5: TKnobsSmallKnob;
    mixm6to6_levelr2c6: TKnobsSmallKnob;
    mixm6to6_levelr3c1: TKnobsSmallKnob;
    mixm6to6_levelr3c2: TKnobsSmallKnob;
    mixm6to6_levelr3c3: TKnobsSmallKnob;
    mixm6to6_levelr3c4: TKnobsSmallKnob;
    mixm6to6_levelr3c5: TKnobsSmallKnob;
    mixm6to6_levelr3c6: TKnobsSmallKnob;
    mixm6to6_levelr4c1: TKnobsSmallKnob;
    mixm6to6_levelr4c2: TKnobsSmallKnob;
    mixm6to6_levelr4c3: TKnobsSmallKnob;
    mixm6to6_levelr4c4: TKnobsSmallKnob;
    mixm6to6_levelr4c5: TKnobsSmallKnob;
    mixm6to6_levelr4c6: TKnobsSmallKnob;
    mixm6to6_levelr5c1: TKnobsSmallKnob;
    mixm6to6_levelr5c2: TKnobsSmallKnob;
    mixm6to6_levelr5c3: TKnobsSmallKnob;
    mixm6to6_levelr5c4: TKnobsSmallKnob;
    mixm6to6_levelr5c5: TKnobsSmallKnob;
    mixm6to6_levelr5c6: TKnobsSmallKnob;
    mixm6to6_levelr6c1: TKnobsSmallKnob;
    mixm6to6_levelr6c2: TKnobsSmallKnob;
    mixm6to6_levelr6c3: TKnobsSmallKnob;
    mixm6to6_levelr6c4: TKnobsSmallKnob;
    mixm6to6_levelr6c5: TKnobsSmallKnob;
    mixm6to6_levelr6c6: TKnobsSmallKnob;
    mixm6to6_mute1: TKnobsSelector;
    mixm6to6_mute2: TKnobsSelector;
    mixm6to6_mute3: TKnobsSelector;
    mixm6to6_mute4: TKnobsSelector;
    mixm6to6_mute5: TKnobsSelector;
    mixm6to6_mute6: TKnobsSelector;
    mixm6to6_out1: TKnobsOutput;
    mixm6to6_out2: TKnobsOutput;
    mixm6to6_out3: TKnobsOutput;
    mixm6to6_out4: TKnobsOutput;
    mixm6to6_out5: TKnobsOutput;
    mixm6to6_out6: TKnobsOutput;
    mixm6to6_outchrow1: TKnobsOutput;
    mixm6to6_outchrow2: TKnobsOutput;
    mixm6to6_outchrow3: TKnobsOutput;
    mixm6to6_outchrow4: TKnobsOutput;
    mixm6to6_outchrow5: TKnobsOutput;
    mixm6to6_outchrow6: TKnobsOutput;
    mixm6to6_textlabel_chains: TKnobsTextLabel;
    mixm6to6_textlabel_in: TKnobsTextLabel;
    mixm6to6_textlabel_out: TKnobsTextLabel;
    mixs2to1: TKnobsModule;
    mixs2to1_editlabel: TKnobsEditLabel;
    mixs2to1_inl1: TKnobsInput;
    mixs2to1_inl2: TKnobsInput;
    mixs2to1_inl: TKnobsInput;
    mixs2to1_inr1: TKnobsInput;
    mixs2to1_inr2: TKnobsInput;
    mixs2to1_inr: TKnobsInput;
    mixs2to1_level1: TKnobsSmallKnob;
    mixs2to1_level2: TKnobsSmallKnob;
    mixs2to1_mute2: TKnobsSelector;
    mixs2to1_mute1: TKnobsSelector;
    mixs2to1_outl: TKnobsOutput;
    mixs2to1_outr: TKnobsOutput;
    multiplier: TKnobsModule;
    multiplier_editlabel: TKnobsEditLabel;
    multiplier_in1: TKnobsInput;
    multiplier_in2: TKnobsInput;
    multiplier_in3: TKnobsInput;
    multiplier_in4: TKnobsInput;
    multiplier_mute: TKnobsSelector;
    multiplier_out: TKnobsOutput;
    noise: TKnobsModule;
    noise_color: TKnobsSmallKnob;
    noise_display_color: TKnobsDisplay;
    noise_editlabel: TKnobsEditLabel;
    noise_mute: TKnobsSelector;
    noise_out: TKnobsOutput;
    noise_textlabel_color: TKnobsTextLabel;
    noiselfo: TKnobsModule;
    noiselfo_color: TKnobsSmallKnob;
    noiselfo_display_color: TKnobsDisplay;
    noiselfo_editlabel: TKnobsEditLabel;
    noiselfo_indicator_out: TKnobsIndicator;
    noiselfo_mute: TKnobsSelector;
    noiselfo_out: TKnobsOutput;
    noiselfo_textlabel_color: TKnobsTextLabel;
    noiselfotrig: TKnobsModule;
    noiselfotrig_color: TKnobsSmallKnob;
    noiselfotrig_display_color: TKnobsDisplay;
    noiselfotrig_editlabel: TKnobsEditLabel;
    noiselfotrig_indicator_out: TKnobsIndicator;
    noiselfotrig_indicator_trig: TKnobsIndicator;
    noiselfotrig_mute: TKnobsSelector;
    noiselfotrig_out: TKnobsOutput;
    noiselfotrig_symbol_trig: TImage;
    noiselfotrig_textlabel_trig: TKnobsTextLabel;
    noiselfotrig_trig: TKnobsInput;
    noiselfotrix_textlabel_color: TKnobsTextLabel;
    noisetrig: TKnobsModule;
    noisetrig_color: TKnobsSmallKnob;
    noisetrig_display_color: TKnobsDisplay;
    noisetrig_editlabel: TKnobsEditLabel;
    noisetrig_mute: TKnobsSelector;
    noisetrig_out: TKnobsOutput;
    noisetrig_symbol_trig: TImage;
    noisetrig_textlabel_color: TKnobsTextLabel;
    noisetrig_textlabel_trig: TKnobsTextLabel;
    noisetrig_trig: TKnobsInput;
    notes: TKnobsModule;
    notes_display: TKnobsDisplay;
    notes_editlabel: TKnobsEditLabel;
    osc_tabsheet: TTabSheet;
    pan: TKnobsModule;
    pan_control: TKnobsInput;
    pan_editlabel: TKnobsEditLabel;
    pan_in: TKnobsInput;
    pan_out1: TKnobsOutput;
    pan_out2: TKnobsOutput;
    pan_position: TKnobsSmallKnob;
    pan_textlabel_control: TKnobsTextLabel;
    pan_textlabel_in: TKnobsTextLabel;
    pan_textlabel_out1: TKnobsTextLabel;
    pan_textlabel_out2: TKnobsTextLabel;
    panel1: TKnobsModule;
    panel2: TKnobsModule;
    panel2_editlabel: TKnobsEditLabel;
    panel3: TKnobsModule;
    panel3_editlabel: TKnobsEditLabel;
    panel4: TKnobsModule;
    panel4_editlabel: TKnobsEditLabel;
    panel5: TKnobsModule;
    panel5_editlabel: TKnobsEditLabel;
    quantize: TKnobsModule;
    quantizer_display_qsteps: TKnobsDisplay;
    quantizer_editlabel: TKnobsEditLabel;
    quantizer_in: TKnobsInput;
    quantizer_mute: TKnobsSelector;
    quantizer_out: TKnobsOutput;
    quantizer_qsteps: TKnobsSmallKnob;
    quantizer_textlabel_in: TKnobsTextLabel;
    quantizer_textlabel_notes: TKnobsTextLabel;
    randomwalklfo: TKnobsModule;
    randomwalklfo_display_distance: TKnobsDisplay;
    randomwalklfo_display_frequency: TKnobsDisplay;
    randomwalklfo_distance: TKnobsSmallKnob;
    randomwalklfo_editlabel: TKnobsEditLabel;
    randomwalklfo_fm: TKnobsInput;
    randomwalklfo_fmlevel: TKnobsSmallKnob;
    randomwalklfo_frequency: TKnobsSmallKnob;
    randomwalklfo_indicator_outx: TKnobsIndicator;
    randomwalklfo_indicator_outy: TKnobsIndicator;
    randomwalklfo_indicator_outz: TKnobsIndicator;
    randomwalklfo_mute: TKnobsSelector;
    randomwalklfo_outx: TKnobsOutput;
    randomwalklfo_outy: TKnobsOutput;
    randomwalklfo_outz: TKnobsOutput;
    randomwalklfo_range: TKnobsSelector;
    randomwalklfo_textlabel_distance: TKnobsTextLabel;
    randomwalklfo_textlabel_fm: TKnobsTextLabel;
    randomwalklfo_textlabel_frequency: TKnobsTextLabel;
    randomwalklfo_textlabel_x: TKnobsTextLabel;
    randomwalklfo_textlabel_y: TKnobsTextLabel;
    randomwalklfo_textlabel_z: TKnobsTextLabel;
    ratio: TKnobsModule;
    ratio_display_divider: TKnobsDisplay;
    ratio_display_multiplier: TKnobsDisplay;
    ratio_divider: TKnobsSmallKnob;
    ratio_editlabel: TKnobsEditLabel;
    ratio_in1: TKnobsInput;
    ratio_in2: TKnobsInput;
    ratio_in3: TKnobsInput;
    ratio_in4: TKnobsInput;
    ratio_multiplier: TKnobsSmallKnob;
    ratio_mute: TKnobsSelector;
    ratio_out1: TKnobsOutput;
    ratio_out2: TKnobsOutput;
    ratio_out3: TKnobsOutput;
    ratio_out4: TKnobsOutput;
    ratio_textlabel_divider: TKnobsTextLabel;
    ratio_textlabel_multiplier: TKnobsTextLabel;
    rectifier: TKnobsModule;
    rectifier_editlabel: TKnobsEditLabel;
    rectifier_in: TKnobsInput;
    rectifier_mode: TKnobsSelector;
    rectifier_out: TKnobsOutput;
    rectifier_outinv: TKnobsOutput;
    rectifier_textlabel_inv: TKnobsTextLabel;
    rotator: TKnobsModule;
    rotator_angle: TKnobsInput;
    rotator_editlabel: TKnobsEditLabel;
    rotator_in1: TKnobsInput;
    rotator_in2: TKnobsInput;
    rotator_out1: TKnobsOutput;
    rotator_out2: TKnobsOutput;
    rotator_textlabel_angle: TKnobsTextLabel;
    rotator_textlabel_ins: TKnobsTextLabel;
    rotator_textlabel_outs: TKnobsTextLabel;
    rsflipflop: TKnobsModule;
    rsflipflop_editlabel: TKnobsEditLabel;
    rsflipflop_image: TImage;
    rsflipflop_indicator_notq: TKnobsIndicator;
    rsflipflop_indicator_q: TKnobsIndicator;
    rsflipflop_notq: TKnobsOutput;
    rsflipflop_q: TKnobsOutput;
    rsflipflop_r: TKnobsInput;
    rsflipflop_s: TKnobsInput;
    sampleandhold: TKnobsModule;
    sampleandhold_editlabel: TKnobsEditLabel;
    sampleandhold_in: TKnobsInput;
    sampleandhold_indicator_trig: TKnobsIndicator;
    sampleandhold_label_in: TKnobsTextLabel;
    sampleandhold_label_trig: TKnobsTextLabel;
    sampleandhold_out: TKnobsOutput;
    sampleandhold_symbol_trig: TImage;
    sampleandhold_trig: TKnobsInput;
    savedstuff_memo: TMemo;
    savedstuff_pagecontrol: TPageControl;
    notes_tabsheet: TTabSheet;
    scaler: TKnobsModule;
    scaler_display_gain: TKnobsDisplay;
    scaler_display_offset: TKnobsDisplay;
    scaler_editlabel: TKnobsEditLabel;
    scaler_gain: TKnobsSmallKnob;
    scaler_in1: TKnobsInput;
    scaler_in2: TKnobsInput;
    scaler_in3: TKnobsInput;
    scaler_in4: TKnobsInput;
    scaler_mode: TKnobsSelector;
    scaler_mute: TKnobsSelector;
    scaler_offset: TKnobsSmallKnob;
    scaler_out1: TKnobsOutput;
    scaler_out2: TKnobsOutput;
    scaler_out3: TKnobsOutput;
    scaler_out4: TKnobsOutput;
    scaler_textlabel_gain: TKnobsTextLabel;
    scaler_textlabel_lock: TKnobsTextLabel;
    scaler_textlabel_offset: TKnobsTextLabel;
    separator_lfo1: TKnobsModule;
    separator_lfo2: TKnobsModule;
    separator_midi: TKnobsModule;
    separator_osc1: TKnobsModule;
    separator_osc4: TKnobsModule;
    separator_util1: TKnobsModule;
    separator_util2: TKnobsModule;
    seqclockstep: TKnobsModule;
    seqclockstep_chain: TKnobsInput;
    seqclockstep_clock: TKnobsInput;
    seqclockstep_counts: TKnobsSmallKnob;
    seqclockstep_dir: TKnobsInput;
    seqclockstep_display_counts: TKnobsDisplay;
    seqclockstep_display_note: TKnobsDisplay;
    seqclockstep_editlabel: TKnobsEditLabel;
    seqclockstep_indicator_active: TKnobsIndicator;
    seqclockstep_indicator_clock: TKnobsIndicator;
    seqclockstep_indicator_count: TKnobsIndicatorText;
    seqclockstep_indicator_dir: TKnobsIndicator;
    seqclockstep_indicator_reset: TKnobsIndicator;
    seqclockstep_indicator_trigbwd: TKnobsIndicator;
    seqclockstep_indicator_trigfwd: TKnobsIndicator;
    seqclockstep_note: TKnobsSmallKnob;
    seqclockstep_out: TKnobsOutput;
    seqclockstep_reset: TKnobsInput;
    seqclockstep_symbol_clockedge: TImage;
    seqclockstep_symbol_sigflow: TImage;
    seqclockstep_symbol_trigbwd: TImage;
    seqclockstep_symbol_trigfwd: TImage;
    seqclockstep_textlabel_clock: TKnobsTextLabel;
    seqclockstep_textlabel_count: TKnobsTextLabel;
    seqclockstep_textlabel_dir: TKnobsTextLabel;
    seqclockstep_textlabel_note: TKnobsTextLabel;
    seqclockstep_textlabel_reset: TKnobsTextLabel;
    seqclockstep_textlabel_trig: TKnobsTextLabel;
    seqclockstep_triginbwd: TKnobsInput;
    seqclockstep_triginfwd: TKnobsInput;
    seqclockstep_trigoutbwd: TKnobsOutput;
    seqclockstep_trigoutfwd: TKnobsOutput;
    seqstep: TKnobsModule;
    seqstep_chain: TKnobsInput;
    seqstep_dir: TKnobsInput;
    seqstep_display_note: TKnobsDisplay;
    seqstep_display_time: TKnobsDisplay;
    seqstep_editlabel: TKnobsEditLabel;
    seqstep_indicator_active: TKnobsIndicator;
    seqstep_indicator_dir: TKnobsIndicator;
    seqstep_indicator_reset: TKnobsIndicator;
    seqstep_indicator_trigbwd: TKnobsIndicator;
    seqstep_indicator_trigfwd: TKnobsIndicator;
    seqstep_note: TKnobsSmallKnob;
    seqstep_out: TKnobsOutput;
    seqstep_reset: TKnobsInput;
    seqstep_symbol_sigflow: TImage;
    seqstep_symbol_trigbwd: TImage;
    seqstep_symbol_trigfwd: TImage;
    seqstep_textlabel_dir: TKnobsTextLabel;
    seqstep_textlabel_duration: TKnobsTextLabel;
    seqstep_textlabel_note: TKnobsTextLabel;
    seqstep_textlabel_res: TKnobsTextLabel;
    seqstep_textlabel_trig: TKnobsTextLabel;
    seqstep_time: TKnobsSmallKnob;
    seqstep_triginbwd: TKnobsInput;
    seqstep_triginfwd: TKnobsInput;
    seqstep_trigoutbwd: TKnobsOutput;
    seqstep_trigoutfwd: TKnobsOutput;
    sequencer: TKnobsModule;
    sequencer_chain: TKnobsInput;
    sequencer_dir: TKnobsInput;
    sequencer_display_step10: TKnobsDisplay;
    sequencer_display_step11: TKnobsDisplay;
    sequencer_display_step1: TKnobsDisplay;
    sequencer_display_step2: TKnobsDisplay;
    sequencer_display_step3: TKnobsDisplay;
    sequencer_display_step4: TKnobsDisplay;
    sequencer_display_step5: TKnobsDisplay;
    sequencer_display_step6: TKnobsDisplay;
    sequencer_display_step7: TKnobsDisplay;
    sequencer_display_step8: TKnobsDisplay;
    sequencer_display_step9: TKnobsDisplay;
    sequencer_display_steps: TKnobsDisplay;
    sequencer_editlabel: TKnobsEditLabel;
    sequencer_indicator_dir: TKnobsIndicator;
    sequencer_indicator_reset: TKnobsIndicator;
    sequencer_indicator_step10: TKnobsIndicator;
    sequencer_indicator_step11: TKnobsIndicator;
    sequencer_indicator_step1: TKnobsIndicator;
    sequencer_indicator_step2: TKnobsIndicator;
    sequencer_indicator_step3: TKnobsIndicator;
    sequencer_indicator_step4: TKnobsIndicator;
    sequencer_indicator_step5: TKnobsIndicator;
    sequencer_indicator_step6: TKnobsIndicator;
    sequencer_indicator_step7: TKnobsIndicator;
    sequencer_indicator_step8: TKnobsIndicator;
    sequencer_indicator_step9: TKnobsIndicator;
    sequencer_indicator_trig: TKnobsIndicator;
    sequencer_out: TKnobsOutput;
    sequencer_reset: TKnobsInput;
    sequencer_step10: TKnobsNoKnob;
    sequencer_step11: TKnobsNoKnob;
    sequencer_step1: TKnobsNoKnob;
    sequencer_step2: TKnobsNoKnob;
    sequencer_step3: TKnobsNoKnob;
    sequencer_step4: TKnobsNoKnob;
    sequencer_step5: TKnobsNoKnob;
    sequencer_step6: TKnobsNoKnob;
    sequencer_step7: TKnobsNoKnob;
    sequencer_step8: TKnobsNoKnob;
    sequencer_step9: TKnobsNoKnob;
    sequencer_steps: TKnobsNoKnob;
    sequencer_symbol_trig: TImage;
    sequencer_tabsheet: TTabSheet;
    sequencer_textlabel_dir: TKnobsTextLabel;
    sequencer_textlabel_reset: TKnobsTextLabel;
    sequencer_textlabel_step10: TKnobsTextLabel;
    sequencer_textlabel_step11: TKnobsTextLabel;
    sequencer_textlabel_step1: TKnobsTextLabel;
    sequencer_textlabel_step2: TKnobsTextLabel;
    sequencer_textlabel_step3: TKnobsTextLabel;
    sequencer_textlabel_step4: TKnobsTextLabel;
    sequencer_textlabel_step5: TKnobsTextLabel;
    sequencer_textlabel_step6: TKnobsTextLabel;
    sequencer_textlabel_step7: TKnobsTextLabel;
    sequencer_textlabel_step8: TKnobsTextLabel;
    sequencer_textlabel_step9: TKnobsTextLabel;
    sequencer_textlabel_steps: TKnobsTextLabel;
    sequencer_textlabel_trig: TKnobsTextLabel;
    sequencer_trig10: TKnobsOutput;
    sequencer_trig11: TKnobsOutput;
    sequencer_trig1: TKnobsOutput;
    sequencer_trig2: TKnobsOutput;
    sequencer_trig3: TKnobsOutput;
    sequencer_trig4: TKnobsOutput;
    sequencer_trig5: TKnobsOutput;
    sequencer_trig6: TKnobsOutput;
    sequencer_trig7: TKnobsOutput;
    sequencer_trig8: TKnobsOutput;
    sequencer_trig9: TKnobsOutput;
    sequencer_trig: TKnobsInput;
    control_tabsheet: TTabSheet;
    osc: TKnobsModule;
    osc_display_frequency: TKnobsDisplay;
    osc_editlabel: TKnobsEditLabel;
    osc_fm: TKnobsInput;
    osc_frequency: TKnobsSmallKnob;
    osc_mute: TKnobsSelector;
    osc_out: TKnobsOutput;
    osc_phase: TKnobsInput;
    osc_sync: TKnobsInput;
    osc_symbol_sync: TImage;
    osc_textlabel_fm: TKnobsTextLabel;
    osc_textlabel_phase: TKnobsTextLabel;
    osctrig: TKnobsModule;
    osctrig_count: TKnobsNoKnob;
    osctrig_display_count: TKnobsDisplay;
    osctrig_display_frequency: TKnobsDisplay;
    osctrig_editlabel: TKnobsEditLabel;
    osctrig_fm: TKnobsInput;
    osctrig_frequency: TKnobsSmallKnob;
    osctrig_mute: TKnobsSelector;
    osctrig_out: TKnobsOutput;
    osctrig_symbol_trig: TImage;
    osctrig_textlabel_fm: TKnobsTextLabel;
    osctrig_textlabel_trig: TKnobsTextLabel;
    osctrig_trig: TKnobsInput;
    square: TKnobsModule;
    square_display_frequency: TKnobsDisplay;
    square_editlabel: TKnobsEditLabel;
    square_fm: TKnobsInput;
    square_frequency: TKnobsSmallKnob;
    square_mute: TKnobsSelector;
    square_out: TKnobsOutput;
    square_phase: TKnobsInput;
    square_pwm: TKnobsInput;
    square_sync: TKnobsInput;
    square_symbol_sync: TImage;
    square_textlabel_fm: TKnobsTextLabel;
    square_textlabel_phase: TKnobsTextLabel;
    square_textlabel_pwm: TKnobsTextLabel;
    square_textlabel_sync: TKnobsTextLabel;
    squarelfo: TKnobsModule;
    squarelfo_display_frequency: TKnobsDisplay;
    squarelfo_editlabel: TKnobsEditLabel;
    squarelfo_fm: TKnobsInput;
    squarelfo_frequency: TKnobsSmallKnob;
    squarelfo_indicator_out: TKnobsIndicator;
    squarelfo_indicator_res: TKnobsIndicator;
    squarelfo_mute: TKnobsSelector;
    squarelfo_out: TKnobsOutput;
    squarelfo_phase: TKnobsInput;
    squarelfo_pwm: TKnobsInput;
    squarelfo_res: TKnobsInput;
    squarelfo_symbol_res: TImage;
    squarelfo_sync: TKnobsOutput;
    squarelfo_textlabel_fm: TKnobsTextLabel;
    squarelfo_textlabel_phase: TKnobsTextLabel;
    squarelfo_textlabel_pwm: TKnobsTextLabel;
    squarelfo_textlabel_res: TKnobsTextLabel;
    squarelfo_textlabel_sync: TKnobsTextLabel;
    squarelfotrig: TKnobsModule;
    squarelfotrig_count: TKnobsNoKnob;
    squarelfotrig_display_count: TKnobsDisplay;
    squarelfotrig_display_frequency: TKnobsDisplay;
    squarelfotrig_editlabel: TKnobsEditLabel;
    squarelfotrig_fm: TKnobsInput;
    squarelfotrig_frequency: TKnobsSmallKnob;
    squarelfotrig_indicator_out: TKnobsIndicator;
    squarelfotrig_indicator_ready: TKnobsIndicator;
    squarelfotrig_indicator_trig: TKnobsIndicator;
    squarelfotrig_mute: TKnobsSelector;
    squarelfotrig_out: TKnobsOutput;
    squarelfotrig_pwm: TKnobsInput;
    squarelfotrig_ready: TKnobsOutput;
    squarelfotrig_symbol_trig: TImage;
    squarelfotrig_textlabel_fm: TKnobsTextLabel;
    squarelfotrig_textlabel_ready: TKnobsTextLabel;
    squarelfotrig_textlabel_trig: TKnobsTextLabel;
    squarelfotrig_trig: TKnobsInput;
    squarelfotrig_textlabel_pwm: TKnobsTextLabel;
    squaretrig: TKnobsModule;
    squaretrig_count: TKnobsNoKnob;
    squaretrig_display_count: TKnobsDisplay;
    squaretrig_display_frequency: TKnobsDisplay;
    squaretrig_editlabel: TKnobsEditLabel;
    squaretrig_fm: TKnobsInput;
    squaretrig_frequency: TKnobsSmallKnob;
    squaretrig_mute: TKnobsSelector;
    squaretrig_out: TKnobsOutput;
    squaretrig_pwm: TKnobsInput;
    squaretrig_symbol_trig: TImage;
    squaretrig_textlabel_fm: TKnobsTextLabel;
    squaretrig_textlabel_pwm: TKnobsTextLabel;
    squaretrig_textlabel_trig: TKnobsTextLabel;
    squaretrig_trig: TKnobsInput;
    svf: TKnobsModule;
    svf_bp: TKnobsOutput;
    svf_br: TKnobsOutput;
    svf_display_frequency: TKnobsDisplay;
    svf_distortion: TKnobsSmallKnob;
    svf_editlabel: TKnobsEditLabel;
    svf_fm: TKnobsInput;
    svf_frequency: TKnobsSmallKnob;
    svf_hp: TKnobsOutput;
    svf_in: TKnobsInput;
    svf_lp: TKnobsOutput;
    svf_q: TKnobsSmallKnob;
    svf_textlabel_bp: TKnobsTextLabel;
    svf_textlabel_br: TKnobsTextLabel;
    svf_textlabel_distortion: TKnobsTextLabel;
    svf_textlabel_frequency_in: TKnobsTextLabel;
    svf_textlabel_hp: TKnobsTextLabel;
    svf_textlabel_in: TKnobsTextLabel;
    svf_textlabel_lp: TKnobsTextLabel;
    svf_textlabel_q: TKnobsTextLabel;
    switch2to1: TKnobsModule;
    switch2to1_control: TKnobsInput;
    switch2to1_editlabel: TKnobsEditLabel;
    switch2to1_in1: TKnobsInput;
    switch2to1_in2: TKnobsInput;
    switch2to1_indicator_control: TKnobsIndicator;
    switch2to1_out: TKnobsOutput;
    switch2to1_textlabel_control: TKnobsTextLabel;
    switch2to1_textlabel_in1: TKnobsTextLabel;
    switch2to1_textlabel_in2: TKnobsTextLabel;
    switch_tabsheet: TTabSheet;
    textsequencer: TKnobsModule;
    textsequencer_dir: TKnobsInput;
    textsequencer_editlabel: TKnobsEditLabel;
    textsequencer_indicator_dir: TKnobsIndicator;
    textsequencer_indicator_reset: TKnobsIndicator;
    textsequencer_indicator_step: TKnobsIndicatorText;
    textsequencer_indicator_steps: TKnobsIndicatorText;
    textsequencer_indicator_trig: TKnobsIndicator;
    textsequencer_label_slash: TLabel;
    textsequencer_mode: TKnobsSelector;
    textsequencer_out: TKnobsOutput;
    textsequencer_reset: TKnobsInput;
    textsequencer_symbol_trig: TImage;
    textsequencer_textlabel_dir: TKnobsTextLabel;
    textsequencer_textlabel_reset: TKnobsTextLabel;
    textsequencer_textlabel_trig: TKnobsTextLabel;
    textsequencer_trig: TKnobsInput;
    textsequencer_values: TKnobsDisplay;
    trackandhold: TKnobsModule;
    trackandhold_editlabel: TKnobsEditLabel;
    trackandhold_in: TKnobsInput;
    trackandhold_indicator_trig: TKnobsIndicator;
    trackandhold_label_in: TKnobsTextLabel;
    trackandhold_label_trig: TKnobsTextLabel;
    trackandhold_out: TKnobsOutput;
    trackandhold_symbol_trig: TImage;
    trackandhold_trig: TKnobsInput;
    util_tabsheet: TTabSheet;
    xfade: TKnobsModule;
    xfade_control: TKnobsInput;
    xfade_editlabel: TKnobsEditLabel;
    xfade_in1: TKnobsInput;
    xfade_in2: TKnobsInput;
    xfade_out: TKnobsOutput;
    xfade_position: TKnobsSmallKnob;
    xfade_textlabel_control: TKnobsTextLabel;
    xfade_textlabel_in1: TKnobsTextLabel;
    xfade_textlabel_in2: TKnobsTextLabel;
    xfade_textlabel_out: TKnobsTextLabel;
    hrastSVF: TKnobsModule;
    hrastSVF_editlable: TKnobsEditLabel;
    hrastSVF_output12: TKnobsOutput;
    hrastSVF_input: TKnobsInput;
    hrastSVF_cutoffinput: TKnobsInput;
    hrastSVF_textlabel_in: TKnobsTextLabel;
    hrastSVF_textlabel_fm: TKnobsTextLabel;
    hrastSVF_textlabel_qm: TKnobsTextLabel;
    hrastSVF_resoinput: TKnobsInput;
    hrastSVF_textlabel_q: TKnobsTextLabel;
    hrastSVF_textlabel_drive: TKnobsTextLabel;
    hrastSVF_textlabel_lp: TKnobsTextLabel;
    hrastSVF_textlabel_bp: TKnobsTextLabel;
    hrastSV_textlabel_hp: TKnobsTextLabel;
    hrastSVF_textlabel_freq: TKnobsTextLabel;
    hrastSVF_textlabel_outlp: TKnobsTextLabel;
    hrastSVF_outputlp: TKnobsOutput;
    hrastSV_textlabel_outbp: TKnobsTextLabel;
    hrastSVF_outputbp: TKnobsOutput;
    hrastSV_textlabel_outhp: TKnobsTextLabel;
    hrastSVF_outputhp: TKnobsOutput;
    hrastSVF_textlabel_outbr: TKnobsTextLabel;
    hrastSVF_outputbr: TKnobsOutput;
    hrastSVF_output24: TKnobsOutput;
    hrastSVF_textlabel_12db: TKnobsTextLabel;
    hrastSVF_textlabel_24db: TKnobsTextLabel;
    hrastSVF_textlabel_out12db: TKnobsTextLabel;
    hrastSVF_textlabel_out24db: TKnobsTextLabel;
    hrastSVF_cutoff: TKnobsSmallKnob;
    hrastSVF_display_cutoff: TKnobsDisplay;
    hrastSVF_lowpass: TKnobsSmallKnob;
    hrastSVF_reso: TKnobsSmallKnob;
    hrastSVF_bandpass: TKnobsSmallKnob;
    hrastSVF_highpass: TKnobsSmallKnob;
    hrastSVF_drive: TKnobsSmallKnob;
    hrastSVF_resomod: TKnobsSmallKnob;
    hrastSVF_cutoffmod: TKnobsSmallKnob;
    hrastSVF_gain: TKnobsSmallKnob;
    hrastSVF_level12: TKnobsSmallKnob;
    hrastSVF_level24: TKnobsSmallKnob;
    ImageHrastSVF: TImage;
    MemoHrastSVF: TMemo;
    osc_shape: TKnobsSelector;
    osc_textlabel_sync: TKnobsTextLabel;
    osc_fmlevel: TKnobsSmallKnob;
    osc_pmlevel: TKnobsSmallKnob;
    osc_cents: TKnobsSmallKnob;
    osc_display_cents: TKnobsDisplay;
    osctrig_shape: TKnobsSelector;
    osctrig_fmlevel: TKnobsSmallKnob;
    osctrig_cents: TKnobsSmallKnob;
    osctrig_display_cents: TKnobsDisplay;
    textsequencer_chain: TKnobsInput;
    svf_fmlevel: TKnobsSmallKnob;
    svf_inlevel: TKnobsSmallKnob;
    mixm4to1_mode: TKnobsSelector;
    mixs2to1_mode: TKnobsSelector;
    mixm6to6_mode: TKnobsSelector;
    square_cents: TKnobsSmallKnob;
    square_display_cents: TKnobsDisplay;
    square_pmlevel: TKnobsSmallKnob;
    square_fmlevel: TKnobsSmallKnob;
    square_pwmlevel: TKnobsSmallKnob;
    squaretrig_cents: TKnobsSmallKnob;
    squaretrig_display_cents: TKnobsDisplay;
    squaretrig_pwmlevel: TKnobsSmallKnob;
    squaretrig_fmlevel: TKnobsSmallKnob;
    squarelfo_fmlevel: TKnobsSmallKnob;
    squarelfo_pmlevel: TKnobsSmallKnob;
    squarelfo_range: TKnobsSelector;
    squarelfo_pwmlevel: TKnobsSmallKnob;
    squarelfotrig_fmlevel: TKnobsSmallKnob;
    squarelfotrig_pwmlevel: TKnobsSmallKnob;
    randomwalklfo_color: TKnobsSmallKnob;
    randomwalklfo_textlabel_color: TKnobsTextLabel;
    hrastosc_cents: TKnobsSmallKnob;
    hrastosc_display_cents: TKnobsDisplay;
    envahd_amodlevel: TKnobsSmallKnob;
    envahd_amod: TKnobsInput;
    envahd_hmodlevel: TKnobsSmallKnob;
    envahd_hmod: TKnobsInput;
    envahd_dmodlevel: TKnobsSmallKnob;
    envahd_dmod: TKnobsInput;
    envahd_hrange: TKnobsSelector;
    envahd_drange: TKnobsSelector;
    envadsr_amodlevel: TKnobsSmallKnob;
    envadsr_amod: TKnobsInput;
    envadsr_dmodlevel: TKnobsSmallKnob;
    envadsr_dmod: TKnobsInput;
    envadsr_smodlevel: TKnobsSmallKnob;
    envadsr_smod: TKnobsInput;
    envadsr_rmodlevel: TKnobsSmallKnob;
    envadsr_rmod: TKnobsInput;
    envadsr_rrange: TKnobsSelector;
    envadsr_drange: TKnobsSelector;
    constant_mode: TKnobsSelector;
    amplifier_mode: TKnobsSelector;
    envahd_amodneg: TKnobsInput;
    envahd_hmodneg: TKnobsInput;
    envahd_dmodneg: TKnobsInput;
    envadsr_amodneg: TKnobsInput;
    envadsr_dmodneg: TKnobsInput;
    envadsr_smodneg: TKnobsInput;
    envadsr_rmodneg: TKnobsInput;
    envahd_textlabel_plus: TKnobsTextLabel;
    envahd_textlabel_minus: TKnobsTextLabel;
    envadsr_textkabel_plus: TKnobsTextLabel;
    envadsr_textkabel_minus: TKnobsTextLabel;
    squarelfo_textlabel_out: TKnobsTextLabel;
    squarelfo_textlabel_trig: TKnobsTextLabel;
    noiselfo_textlabel_out: TKnobsTextLabel;
    noiselfotrig_textlabel_out: TKnobsTextLabel;
    intdif: TKnobsModule;
    intdif_editlabel: TKnobsEditLabel;
    intdif_int: TKnobsOutput;
    intdif_dif: TKnobsOutput;
    intdif_in: TKnobsInput;
    intdif_textlabel_int: TKnobsTextLabel;
    intdif_textlabel_dif: TKnobsTextLabel;
    ImageIntDif: TImage;
    MemoIntDif: TMemo;
    squarelfotrig_range: TKnobsSelector;
    randsig: TKnobsModule;
    randsig_editlabel: TKnobsEditLabel;
    randsig_out: TKnobsOutput;
    randsig_fm: TKnobsInput;
    randsig_indicator_active: TKnobsIndicator;
    randsig_textlabel_fm: TKnobsTextLabel;
    randsig_textlabel_out: TKnobsTextLabel;
    randsig_frequency: TKnobsSmallKnob;
    randsig_display_frequency: TKnobsDisplay;
    randsig_mute: TKnobsSelector;
    randsig_range: TKnobsSelector;
    randsig_fmlevel: TKnobsSmallKnob;
    intdif_textlabel_in: TKnobsTextLabel;
    intdif_mode: TKnobsSelector;
    separator_osc2: TKnobsModule;
    terragen: TKnobsModule;
    terragen_editlabel: TKnobsEditLabel;
    terragen_out: TKnobsOutput;
    terragen_x: TKnobsInput;
    terragen_textlabel_height: TKnobsTextLabel;
    terragen_mute: TKnobsSelector;
    terragen_textlabel_x: TKnobsTextLabel;
    terragen_textlabel_y: TKnobsTextLabel;
    terragen_y: TKnobsInput;
    terragen_algo: TKnobsSelector;
    envelope: TKnobsModule;
    envelope_out: TKnobsOutput;
    envelope_in: TKnobsInput;
    envelope_editlabel: TKnobsEditLabel;
    envelope_textlabel_a: TKnobsTextLabel;
    envelope_textlabel_r: TKnobsTextLabel;
    envelope_attack: TKnobsSmallKnob;
    envelope_release: TKnobsSmallKnob;
    envelope_display_attack: TKnobsDisplay;
    envelope_display_release: TKnobsDisplay;
    separator_env: TKnobsModule;
    formant: TKnobsModule;
    formant_out: TKnobsOutput;
    formant_in: TKnobsInput;
    formant_editlabel: TKnobsEditLabel;
    formant_textlabel_in: TKnobsTextLabel;
    formant_vowel: TKnobsSmallKnob;
    formant_textlabel_control: TKnobsTextLabel;
    formant_vowelin: TKnobsInput;
    MemoTerraGen: TMemo;
    ImageTerraGen: TImage;
    ImageRandSig: TImage;
    MemoRandSig: TMemo;
    ImageEnvelope: TImage;
    MemoEnvelope: TMemo;
    ImageFormant: TImage;
    MemoFormant: TMemo;
    envar_textlable_env: TKnobsTextLabel;
    envarretrig_textlabel_env: TKnobsTextLabel;
    scaler_sum: TKnobsOutput;
    scaler_textlabel_sum: TKnobsTextLabel;
    envelope_invout: TKnobsOutput;
    envelope_textlabel_env: TKnobsTextLabel;
    envelope_textlabel_inv: TKnobsTextLabel;
    envelope_peakdecay: TKnobsSmallKnob;
    envelope_peakdecayon: TKnobsSelector;
    envelope_textlabel_peakdecay: TKnobsTextLabel;
    randsig_outputtype: TKnobsSelector;
    lfo_outputtype: TKnobsSelector;
    squarelfo_outputtype: TKnobsSelector;
    noiselfo_outputtype: TKnobsSelector;
    randomwalklfo_outputtype: TKnobsSelector;
    lfotrig_outputtype: TKnobsSelector;
    squarelfotrig_outputtype: TKnobsSelector;
    noiselfotrig_outputtype: TKnobsSelector;
    envahd_outputtype: TKnobsSelector;
    envadsr_outputtype: TKnobsSelector;
    audioout_textlabel_1: TKnobsTextLabel;
    audioout_in4: TKnobsInput;
    audioout_in3: TKnobsInput;
    audioout_textlabel_r_in2: TKnobsTextLabel;
    audioout_textlabel_l_in2: TKnobsTextLabel;
    audioout_textlabel_2: TKnobsTextLabel;
    audioout_in6: TKnobsInput;
    audioout_in5: TKnobsInput;
    audioout_textlabel_r_in3: TKnobsTextLabel;
    audioout_textlabel_l_in3: TKnobsTextLabel;
    audioout_textlabel_3: TKnobsTextLabel;
    audioout_in8: TKnobsInput;
    audioout_in7: TKnobsInput;
    audioout_textlabel_r_in4: TKnobsTextLabel;
    audioout_textlabel_l_in4: TKnobsTextLabel;
    audioout_textlabel_4: TKnobsTextLabel;
    audioin_out3: TKnobsOutput;
    audioin_out4: TKnobsOutput;
    audioin_textlabel_r_out2: TKnobsTextLabel;
    audioin_textlabel_l_out2: TKnobsTextLabel;
    audioin_out5: TKnobsOutput;
    audioin_out6: TKnobsOutput;
    audioin_textlabel_r_out3: TKnobsTextLabel;
    audioin_textlabel_l_out3: TKnobsTextLabel;
    audioin_out7: TKnobsOutput;
    audioin_out8: TKnobsOutput;
    audioin_textlabel_r_out4: TKnobsTextLabel;
    audioin_textlabel_l_out4: TKnobsTextLabel;
    audioin_textlabel_1: TKnobsTextLabel;
    audioin_textlabel_2: TKnobsTextLabel;
    audioin_textlabel_3: TKnobsTextLabel;
    audioin_textlabel_4: TKnobsTextLabel;
    euclids: TKnobsModule;
    euclids_editlabel: TKnobsEditLabel;
    euclids_out: TKnobsOutput;
    euclids_indicator_out: TKnobsIndicator;
    euclids_textlabel_out: TKnobsTextLabel;
    euclids_symbol_trig: TImage;
    euclids_trig: TKnobsInput;
    euclids_indicator_trig: TKnobsIndicator;
    euclids_textlabel_trig: TKnobsTextLabel;
    euclids_patternmod: TKnobsSmallKnob;
    euclids_pattern: TKnobsInput;
    euclids_textlabel_pattern: TKnobsTextLabel;
    euclids_textlabel_steps: TKnobsTextLabel;
    euclids_steps: TKnobsSmallKnob;
    euclids_pulses: TKnobsSmallKnob;
    euclids_display_steps: TKnobsDisplay;
    euclids_textlabel_mod: TKnobsTextLabel;
    csvdata: TKnobsModule;
    csvdata_symbol_trig: TImage;
    csvdata_dir: TKnobsInput;
    csvdata_trig: TKnobsInput;
    csvdata_reset: TKnobsInput;
    csvdata_editlabel: TKnobsEditLabel;
    csvdata_indicator_trig: TKnobsIndicator;
    csvdata_indicator_dir: TKnobsIndicator;
    csvdata_indicator_reset: TKnobsIndicator;
    csvdata_textlabel_trig: TKnobsTextLabel;
    csvdata_textlabel_dir: TKnobsTextLabel;
    csvdata_textlabel_res: TKnobsTextLabel;
    csvdata_out1: TKnobsOutput;
    csvdata_out2: TKnobsOutput;
    csvdata_out3: TKnobsOutput;
    csvdata_out4: TKnobsOutput;
    csvdata_out5: TKnobsOutput;
    csvdata_out6: TKnobsOutput;
    csvdata_out7: TKnobsOutput;
    csvdata_out8: TKnobsOutput;
    csvdata_out9: TKnobsOutput;
    csvdata_out10: TKnobsOutput;
    csvdata_out11: TKnobsOutput;
    csvdata_textlabel_1: TKnobsTextLabel;
    csvdata_textlabel_2: TKnobsTextLabel;
    csvdata_textlabel_3: TKnobsTextLabel;
    csvdata_textlabel_4: TKnobsTextLabel;
    csvdata_textlabel_5: TKnobsTextLabel;
    csvdata_textlabel_6: TKnobsTextLabel;
    csvdata_textlabel_7: TKnobsTextLabel;
    csvdata_textlabel_8: TKnobsTextLabel;
    csvdata_textlabel_9: TKnobsTextLabel;
    csvdata_textlabel_10: TKnobsTextLabel;
    csvdata_textlabel_11: TKnobsTextLabel;
    csvdata_fileselector_filename: TKnobsFileSelector;
    csvdata_indicator_step: TKnobsIndicatorText;
    csvdata_label_slash: TLabel;
    csvdata_indicator_steps: TKnobsIndicatorText;
    csvdata_indicator_channels: TKnobsIndicatorText;
    csvdata_display_comment: TKnobsDisplay;
    csvdata_mode: TKnobsSelector;
    csvdata_textlabel_mode: TKnobsTextLabel;
    display_speed: TKnobsSelector;
    csvdata_textlabel_channels: TKnobsTextLabel;
    gate_width: TKnobsSelector;
    csvdata_out12: TKnobsOutput;
    csvdata_out13: TKnobsOutput;
    csvdata_out14: TKnobsOutput;
    csvdata_out15: TKnobsOutput;
    csvdata_out16: TKnobsOutput;
    csvdata_textlabel_12: TKnobsTextLabel;
    csvdata_textlabel_13: TKnobsTextLabel;
    csvdata_textlabel_14: TKnobsTextLabel;
    csvdata_textlabel_15: TKnobsTextLabel;
    csvdata_textlabel_16: TKnobsTextLabel;
    MemoEuclideanRhythm: TMemo;
    MemoCsvData: TMemo;
    ImageEuclideanRhythm: TImage;
    ImageCsvData: TImage;
    counter: TKnobsModule;
    counter_editlabel: TKnobsEditLabel;
    counter_symbol_trig: TImage;
    counter_out0: TKnobsOutput;
    counter_trig: TKnobsInput;
    counter_indicator_out0: TKnobsIndicator;
    counter_textlabel_trig: TKnobsTextLabel;
    counter_symbol_reset: TImage;
    counter_reset: TKnobsInput;
    counter_textlabel_reset: TKnobsTextLabel;
    counter_out1: TKnobsOutput;
    counter_indicator_out1: TKnobsIndicator;
    counter_out2: TKnobsOutput;
    counter_indicator_out2: TKnobsIndicator;
    counter_out3: TKnobsOutput;
    counter_indicator_out3: TKnobsIndicator;
    counter_out4: TKnobsOutput;
    counter_indicator_out4: TKnobsIndicator;
    counter_out5: TKnobsOutput;
    counter_indicator_out5: TKnobsIndicator;
    counter_out6: TKnobsOutput;
    counter_indicator_out6: TKnobsIndicator;
    counter_out7: TKnobsOutput;
    counter_indicator_out7: TKnobsIndicator;
    counter_out8: TKnobsOutput;
    counter_indicator_out8: TKnobsIndicator;
    counter_out9: TKnobsOutput;
    counter_indicator_out9: TKnobsIndicator;
    counter_out10: TKnobsOutput;
    counter_indicator_out10: TKnobsIndicator;
    counter_out11: TKnobsOutput;
    counter_indicator_out11: TKnobsIndicator;
    counter_out12: TKnobsOutput;
    counter_indicator_out12: TKnobsIndicator;
    counter_out13: TKnobsOutput;
    counter_indicator_out13: TKnobsIndicator;
    counter_out14: TKnobsOutput;
    counter_indicator_out14: TKnobsIndicator;
    counter_out15: TKnobsOutput;
    counter_indicator_out15: TKnobsIndicator;
    counter_textlabel_1: TKnobsTextLabel;
    counter_textlabel_2: TKnobsTextLabel;
    counter_textlabel_3: TKnobsTextLabel;
    counter_textlabel_4: TKnobsTextLabel;
    counter_textlabel_5: TKnobsTextLabel;
    counter_textlabel_6: TKnobsTextLabel;
    counter_textlabel_7: TKnobsTextLabel;
    counter_textlabel_8: TKnobsTextLabel;
    counter_textlabel_9: TKnobsTextLabel;
    counter_textlabel_10: TKnobsTextLabel;
    counter_textlabel_11: TKnobsTextLabel;
    counter_textlabel_12: TKnobsTextLabel;
    counter_textlabel_13: TKnobsTextLabel;
    counter_textlabel_14: TKnobsTextLabel;
    counter_textlabel_15: TKnobsTextLabel;
    counter_textlabel_16: TKnobsTextLabel;
    counter_mode: TKnobsSelector;
    ImageCounter: TImage;
    MemoCounter: TMemo;
    counter_textlabel_dir: TKnobsTextLabel;
    counter_dir: TKnobsInput;
    counter_indicator_trig: TKnobsIndicator;
    counter_indicator_reset: TKnobsIndicator;
    counter_indicator_dir: TKnobsIndicator;
    adc: TKnobsModule;
    adc_editlabel: TKnobsEditLabel;
    adc_out0: TKnobsOutput;
    adc_in: TKnobsInput;
    adc_indicator_out0: TKnobsIndicator;
    adc_out1: TKnobsOutput;
    adc_indicator_out1: TKnobsIndicator;
    adc_out2: TKnobsOutput;
    adc_indicator_out2: TKnobsIndicator;
    adc_out3: TKnobsOutput;
    adc_indicator_out3: TKnobsIndicator;
    adc_out4: TKnobsOutput;
    adc_indicator_out4: TKnobsIndicator;
    adc_out5: TKnobsOutput;
    adc_indicator_out5: TKnobsIndicator;
    adc_out6: TKnobsOutput;
    adc_indicator_out6: TKnobsIndicator;
    adc_out7: TKnobsOutput;
    adc_indicator_out7: TKnobsIndicator;
    adc_out8: TKnobsOutput;
    adc_indicator_out8: TKnobsIndicator;
    adc_out9: TKnobsOutput;
    adc_indicator_out9: TKnobsIndicator;
    adc_out10: TKnobsOutput;
    adc_indicator_out10: TKnobsIndicator;
    adc_out11: TKnobsOutput;
    adc_indicator_out11: TKnobsIndicator;
    adc_out12: TKnobsOutput;
    adc_indicator_out12: TKnobsIndicator;
    adc_out13: TKnobsOutput;
    adc_indicator_out13: TKnobsIndicator;
    adc_out14: TKnobsOutput;
    adc_indicator_out14: TKnobsIndicator;
    adc_out15: TKnobsOutput;
    adc_indicator_out15: TKnobsIndicator;
    adc_textlabel_0: TKnobsTextLabel;
    adc_textlabel_1: TKnobsTextLabel;
    adc_textlabel_2: TKnobsTextLabel;
    adc_textlabel_3: TKnobsTextLabel;
    adc_textlabel_4: TKnobsTextLabel;
    adc_textlabel_5: TKnobsTextLabel;
    adc_textlabel_6: TKnobsTextLabel;
    adc_textlabel_7: TKnobsTextLabel;
    adc_textlabel_8: TKnobsTextLabel;
    adc_textlabel_9: TKnobsTextLabel;
    adc_textlabel_10: TKnobsTextLabel;
    adc_textlabel_11: TKnobsTextLabel;
    adc_textlabel_12: TKnobsTextLabel;
    adc_textlabel_13: TKnobsTextLabel;
    adc_textlabel_14: TKnobsTextLabel;
    adc_textlabel_15: TKnobsTextLabel;
    adc_textlabel_in: TKnobsTextLabel;
    dac: TKnobsModule;
    dac_editlabel: TKnobsEditLabel;
    dac_indicator_in0: TKnobsIndicator;
    dac_indicator_in1: TKnobsIndicator;
    dac_indicator_in2: TKnobsIndicator;
    dac_indicator_in3: TKnobsIndicator;
    dac_indicator_in4: TKnobsIndicator;
    dac_indicator_in5: TKnobsIndicator;
    dac_indicator_in6: TKnobsIndicator;
    dac_indicator_in7: TKnobsIndicator;
    dac_indicator_in8: TKnobsIndicator;
    dac_indicator_in9: TKnobsIndicator;
    dac_indicator_in10: TKnobsIndicator;
    dac_indicator_in11: TKnobsIndicator;
    dac_indicator_in12: TKnobsIndicator;
    dac_indicator_in13: TKnobsIndicator;
    dac_indicator_in14: TKnobsIndicator;
    dac_indicator_in15: TKnobsIndicator;
    dac_textlabel_0: TKnobsTextLabel;
    dac_textlabel_1: TKnobsTextLabel;
    dac_textlabel_2: TKnobsTextLabel;
    dac_textlabel_3: TKnobsTextLabel;
    dac_textlabel_4: TKnobsTextLabel;
    dac_textlabel_5: TKnobsTextLabel;
    dac_textlabel_6: TKnobsTextLabel;
    dac_textlabel_7: TKnobsTextLabel;
    dac_textlabel_8: TKnobsTextLabel;
    dac_textlabel_9: TKnobsTextLabel;
    dac_textlabel_10: TKnobsTextLabel;
    dac_textlabel_11: TKnobsTextLabel;
    dac_textlabel_12: TKnobsTextLabel;
    dac_textlabel_13: TKnobsTextLabel;
    dac_textlabel_14: TKnobsTextLabel;
    dac_textlabel_15: TKnobsTextLabel;
    dac_textlabel_out: TKnobsTextLabel;
    dac_out: TKnobsOutput;
    dac_in0: TKnobsInput;
    dac_in1: TKnobsInput;
    dac_in2: TKnobsInput;
    dac_in3: TKnobsInput;
    dac_in4: TKnobsInput;
    dac_in5: TKnobsInput;
    dac_in6: TKnobsInput;
    dac_in7: TKnobsInput;
    dac_in8: TKnobsInput;
    dac_in9: TKnobsInput;
    dac_in10: TKnobsInput;
    dac_in11: TKnobsInput;
    dac_in12: TKnobsInput;
    dac_in13: TKnobsInput;
    dac_in14: TKnobsInput;
    dac_in15: TKnobsInput;
    MemoAdc: TMemo;
    ImageAdc: TImage;
    MemoDac: TMemo;
    ImageDac: TImage;
    multimult: TKnobsModule;
    multimult_editlabel: TKnobsEditLabel;
    multimult_out1: TKnobsOutput;
    multimult_in4: TKnobsInput;
    multimult_in3: TKnobsInput;
    multimult_in2: TKnobsInput;
    multimult_in1: TKnobsInput;
    ImageMultiMult: TImage;
    MemoMultiMult: TMemo;
    multimult_out4: TKnobsOutput;
    multimult_out3: TKnobsOutput;
    multimult_out2: TKnobsOutput;
    multimult_mult: TKnobsInput;
    multimult_textlabel_mult: TKnobsTextLabel;
    mixm4to1_levmod3: TKnobsInput;
    mixm4to1_levmod4: TKnobsInput;
    mixm4to1_levmod2: TKnobsInput;
    mixm4to1_levmod1: TKnobsInput;
    mixs2to1_levmod1: TKnobsInput;
    mixs2to1_levmod2: TKnobsInput;
    xfade_posmod: TKnobsSmallKnob;
    pan_posmod: TKnobsSmallKnob;
    formant_controlmod: TKnobsSmallKnob;
    formant_textlabel_vowel: TKnobsTextLabel;
    separator_filter1: TKnobsModule;
    ImageListLfoOutputType: TImageList;
    ImageListEnvOutputType: TImageList;
    ImageListStandardWaveShapes: TImageList;
    Lfo_textlabel_shape: TKnobsTextLabel;
    lfotrig_textlabel_shape: TKnobsTextLabel;
    osc_textlabel_shape: TKnobsTextLabel;
    osctrig_textlabel_shape: TKnobsTextLabel;
    osctrig_textlabel_count: TKnobsTextLabel;
    squaretrig_textlabel_count: TKnobsTextLabel;
    lfotrig_textlabel_count: TKnobsTextLabel;
    squarelfotrig_textlabel_count: TKnobsTextLabel;
    kleebit: TKnobsModule;
    kleebit_editlabel: TKnobsEditLabel;
    kleebit_indicator_step1: TKnobsIndicator;
    kleebit_indicator_step2: TKnobsIndicator;
    kleebit_indicator_step3: TKnobsIndicator;
    kleebit_indicator_step4: TKnobsIndicator;
    kleebit_indicator_step5: TKnobsIndicator;
    kleebit_indicator_step6: TKnobsIndicator;
    kleebit_indicator_step7: TKnobsIndicator;
    kleebit_indicator_step8: TKnobsIndicator;
    kleebit_textlabel_1: TKnobsTextLabel;
    kleebit_textlabel_2: TKnobsTextLabel;
    kleebit_textlabel_3: TKnobsTextLabel;
    kleebit_textlabel_4: TKnobsTextLabel;
    kleebit_textlabel_5: TKnobsTextLabel;
    kleebit_textlabel_6: TKnobsTextLabel;
    kleebit_textlabel_7: TKnobsTextLabel;
    kleebit_textlabel_8: TKnobsTextLabel;
    kleebit_outanalog: TKnobsOutput;
    kleebit_outbus1: TKnobsOutput;
    kleebit_level1: TKnobsSmallKnob;
    kleebit_level2: TKnobsSmallKnob;
    kleebit_level3: TKnobsSmallKnob;
    kleebit_level4: TKnobsSmallKnob;
    kleebit_level5: TKnobsSmallKnob;
    kleebit_level6: TKnobsSmallKnob;
    kleebit_level7: TKnobsSmallKnob;
    kleebit_level8: TKnobsSmallKnob;
    kleebit_inload: TKnobsInput;
    kleebit_indicator_load: TKnobsIndicator;
    kleebit_textlabel_load: TKnobsTextLabel;
    kleebit_bussel1: TKnobsSelector;
    kleebit_bussel2: TKnobsSelector;
    kleebit_bussel3: TKnobsSelector;
    kleebit_bussel4: TKnobsSelector;
    kleebit_bussel5: TKnobsSelector;
    kleebit_bussel6: TKnobsSelector;
    kleebit_bussel7: TKnobsSelector;
    kleebit_bussel8: TKnobsSelector;
    kleebit_loopmode: TKnobsSelector;
    kleebit_pre1: TKnobsSelector;
    kleebit_pre2: TKnobsSelector;
    kleebit_pre3: TKnobsSelector;
    kleebit_pre4: TKnobsSelector;
    kleebit_pre5: TKnobsSelector;
    kleebit_pre6: TKnobsSelector;
    kleebit_pre7: TKnobsSelector;
    kleebit_pre8: TKnobsSelector;
    kleebit_inanalog: TKnobsInput;
    kleebit_inbus1: TKnobsInput;
    kleebit_instep: TKnobsInput;
    kleebit_indicator_step: TKnobsIndicator;
    kleebit_textlabel_step: TKnobsTextLabel;
    kleebit_inbus2: TKnobsInput;
    kleebit_inbus3: TKnobsInput;
    kleebit_outbus2: TKnobsOutput;
    kleebit_outbus3: TKnobsOutput;
    kleebit_indicator_bus1: TKnobsIndicator;
    kleebit_indicator_bus2: TKnobsIndicator;
    kleebit_indicator_bus3: TKnobsIndicator;
    kleebit_textlabel_a: TKnobsTextLabel;
    kleebit_textlabel_bus1: TKnobsTextLabel;
    kleebit_textlabel_pre: TKnobsTextLabel;
    kleebit_box_pre: TKnobsBox;
    kleebit_box_analog: TKnobsBox;
    kleebit_box_bus1: TKnobsBox;
    kleebit_box_bus2: TKnobsBox;
    kleebit_box_bus3: TKnobsBox;
    kleebit_textlabel_bus2: TKnobsTextLabel;
    kleebit_textlabel_bus3: TKnobsTextLabel;
    kleebit_inbit: TKnobsInput;
    kleebit_textlabel_inbit: TKnobsTextLabel;
    kleebit_outbit: TKnobsOutput;
    kleebit_textlabel_outbit: TKnobsTextLabel;
    kleebit_indicator_inbit: TKnobsIndicator;
    kleebit_indicator_outbit: TKnobsIndicator;
    ImageKleeBit: TImage;
    MemoKleeBit: TMemo;
    kleebit_invertmode: TKnobsSelector;
    kleebit_textlabel_outinvert: TKnobsTextLabel;
    kleebit_loopinvert: TKnobsInput;
    kleebit_invertinvert: TKnobsInput;
    kleebit_mainlevel: TKnobsSmallKnob;
    kleebit_textlabel_mainlev: TKnobsTextLabel;
    kleebit_indicator_invert: TKnobsIndicator;
    kleebit_indicator_loop: TKnobsIndicator;
    kleebit_mainlevelmod: TKnobsInput;
    kleebit_outinvert: TKnobsOutput;
    kleebit_outloop: TKnobsOutput;
    pinkfilter: TKnobsModule;
    pinkfilter_out: TKnobsOutput;
    pinkfilter_in: TKnobsInput;
    pinkfilter_editlabel: TKnobsEditLabel;
    pinkfilter_texxtlabel_in: TKnobsTextLabel;
    pinkfilter_textlabel_gain: TKnobsTextLabel;
    pinkfilter_gain: TKnobsSmallKnob;
    ImagePinkFilter: TImage;
    MemoPinkFilter: TMemo;
    pinkfilter_mode: TKnobsSelector;
    envahd_indicator_trigin: TKnobsIndicator;
    envadsr_indicator_trigin: TKnobsIndicator;
    seqrandom: TKnobsModule;
    seqrandom_editlabel: TKnobsEditLabel;
    seqrandom_out: TKnobsOutput;
    seqrandom_textlabel_out: TKnobsTextLabel;
    seqrandom_symbol_trig: TImage;
    seqrandom_trig: TKnobsInput;
    seqrandom_indicator_trig: TKnobsIndicator;
    seqrandom_textlabel_step: TKnobsTextLabel;
    seqrandom_textlabel_lownote: TKnobsTextLabel;
    seqrandom_lownote: TKnobsSmallKnob;
    seqrandom_display_lownote: TKnobsDisplay;
    seqrandom_display_highnote: TKnobsDisplay;
    seqrandom_highnote: TKnobsSmallKnob;
    seqrandom_textlabel_highnote: TKnobsTextLabel;
    seqrandom_scale: TKnobsSelector;
    seqrandom_textlabel_scale: TKnobsTextLabel;
    seqrandom_textlabel_basenote: TKnobsTextLabel;
    seqrandom_basenote: TKnobsSmallKnob;
    seqrandom_display_basenote: TKnobsDisplay;
    seqrandom_textlabel_count: TKnobsTextLabel;
    seqrandom_count: TKnobsSmallKnob;
    seqrandom_display_count: TKnobsDisplay;
    ImageSeqRandom: TImage;
    MemoSeqRandom: TMemo;
    seqrandom_symbol_changeone: TImage;
    seqrandom_changeone: TKnobsInput;
    seqrandom_indicator_changeone: TKnobsIndicator;
    seqrandom_textlabel_change: TKnobsTextLabel;
    multisandh: TKnobsModule;
    multisandh_editlabel: TKnobsEditLabel;
    multisandh_symbol_trig: TImage;
    multisandh_out1: TKnobsOutput;
    multisandh_in1: TKnobsInput;
    multisandh_trig: TKnobsInput;
    multisandh_indicator_trig: TKnobsIndicator;
    multisandh_textlabel_in: TKnobsTextLabel;
    multisandh_textlabel_trig: TKnobsTextLabel;
    ImageMultiSAndH: TImage;
    Memo1MultiSAndH: TMemo;
    multisandh_textlabel_out: TKnobsTextLabel;
    multisandh_out2: TKnobsOutput;
    multisandh_in2: TKnobsInput;
    multisandh_out3: TKnobsOutput;
    multisandh_in3: TKnobsInput;
    multisandh_out4: TKnobsOutput;
    multisandh_in4: TKnobsInput;
    multisandh_out5: TKnobsOutput;
    multisandh_in5: TKnobsInput;
    multisandh_out6: TKnobsOutput;
    multisandh_in6: TKnobsInput;
    multisandh_out7: TKnobsOutput;
    multisandh_in7: TKnobsInput;
    multisandh_out8: TKnobsOutput;
    multisandh_in8: TKnobsInput;
    multisandh_out9: TKnobsOutput;
    multisandh_in9: TKnobsInput;
    multisandh_out10: TKnobsOutput;
    multisandh_in10: TKnobsInput;
    multisandh_out11: TKnobsOutput;
    multisandh_in11: TKnobsInput;
    multisandh_out12: TKnobsOutput;
    multisandh_in12: TKnobsInput;
    multimult_out5: TKnobsOutput;
    multimult_in8: TKnobsInput;
    multimult_in7: TKnobsInput;
    multimult_in6: TKnobsInput;
    multimult_in5: TKnobsInput;
    multimult_out8: TKnobsOutput;
    multimult_out7: TKnobsOutput;
    multimult_out6: TKnobsOutput;
    notetodelay: TKnobsModule;
    notetodelay_editlabel: TKnobsEditLabel;
    notetodelay_out: TKnobsOutput;
    notetodelay_in: TKnobsInput;
    notetodelay_textlabel_out: TKnobsTextLabel;
    notetodelay_textlabel_in: TKnobsTextLabel;
    ImageNoteToDelay: TImage;
    MemoNoteToDelay: TMemo;
    separator_osc3: TKnobsModule;
    pluck: TKnobsModule;
    pluck_editlabel: TKnobsEditLabel;
    pluck_out: TKnobsOutput;
    pluck_fm: TKnobsInput;
    pluck_pluck: TKnobsInput;
    pluck_textlabel_fm: TKnobsTextLabel;
    pluck_textlabel_feedback: TKnobsTextLabel;
    pluck_textlabel_pluck: TKnobsTextLabel;
    pluck_frequency: TKnobsSmallKnob;
    pluck_display_frequency: TKnobsDisplay;
    pluck_mute: TKnobsSelector;
    pluck_fmlevel: TKnobsSmallKnob;
    pluck_feedback: TKnobsSmallKnob;
    pluck_cents: TKnobsSmallKnob;
    pluck_display_cents: TKnobsDisplay;
    pluck_textlabel_brightnesss: TKnobsTextLabel;
    pluck_brightness: TKnobsSmallKnob;
    ImagePluck: TImage;
    MemoPluck: TMemo;
    pluck_plucklevel: TKnobsSmallKnob;
    pluck_bclevel: TKnobsSmallKnob;
    pluck_brighctrl: TKnobsInput;
    mixt1to1: TKnobsModule;
    mixt1to1_editlabel: TKnobsEditLabel;
    mixt1to1_outr: TKnobsOutput;
    mixt1to1_inl1: TKnobsInput;
    mixt1to1_inr1: TKnobsInput;
    mixt1to1_inr: TKnobsInput;
    mixt1to1_inm: TKnobsInput;
    mixt1to1_outm: TKnobsOutput;
    mixt1to1_inm1: TKnobsInput;
    mixt1to1_inl: TKnobsInput;
    mixt1to1_levmod1: TKnobsInput;
    mixt1to1_level1: TKnobsSmallKnob;
    mixt1to1_mute1: TKnobsSelector;
    mixt1to1_mode: TKnobsSelector;
    mixt1to1_outl: TKnobsOutput;
    MemoMixT1to1: TMemo;
    ImageMixT1to1: TImage;
    pluck_noisemod: TKnobsInput;
    pluck_noisedepth: TKnobsSmallKnob;
    pluck_noise: TKnobsSmallKnob;
    pluck_textlabel_noise: TKnobsTextLabel;
    resonator: TKnobsModule;
    resonator_editlabel: TKnobsEditLabel;
    resonator_out: TKnobsOutput;
    resonator_freq: TKnobsInput;
    resonator_in: TKnobsInput;
    resonator_textlabel_freq: TKnobsTextLabel;
    resonator_textlabel_in: TKnobsTextLabel;
    resonator_textlabel_out: TKnobsTextLabel;
    resonator_textlabel_decay: TKnobsTextLabel;
    resonator_decay: TKnobsSmallKnob;
    resonator_display_damp: TKnobsDisplay;
    ImageResonator: TImage;
    MemoResonator: TMemo;
    fx_tabsheet: TTabSheet;
    ImageReverb: TImage;
    ImageFlangeChorus: TImage;
    ImagePitchChange: TImage;
    reverb: TKnobsModule;
    reverb_editlabel: TKnobsEditLabel;
    reverb_inl: TKnobsInput;
    reverb_inr: TKnobsInput;
    reverb_textlabel_damp: TKnobsTextLabel;
    reverb_textlabel_size: TKnobsTextLabel;
    reverb_textlabel_wet: TKnobsTextLabel;
    reverb_textlabel_dry: TKnobsTextLabel;
    reverb_textlabel_width: TKnobsTextLabel;
    reverb_textlabel_l: TKnobsTextLabel;
    reverb_outl: TKnobsOutput;
    reverb_textlabel_r: TKnobsTextLabel;
    reverb_outr: TKnobsOutput;
    reverb_freezein: TKnobsInput;
    reverb_wet: TKnobsSmallKnob;
    reverb_damp: TKnobsSmallKnob;
    reverb_dry: TKnobsSmallKnob;
    reverb_width: TKnobsSmallKnob;
    reverb_roomsize: TKnobsSmallKnob;
    reverb_mode: TKnobsSelector;
    reverb_mute: TKnobsSelector;
    Memoreverb: TMemo;
    flangechorus: TKnobsModule;
    flangechorus_editlabel: TKnobsEditLabel;
    flangechorus_in: TKnobsInput;
    flangechorus_textlabel_rate: TKnobsTextLabel;
    flangechorus_textlabel_feedback: TKnobsTextLabel;
    flangechorus_textlabel_wet: TKnobsTextLabel;
    flangechorus_textlabel_dry: TKnobsTextLabel;
    flangechorus_textlabel_sweep: TKnobsTextLabel;
    flangechorus_out: TKnobsOutput;
    flangechorus_textlabel_delay: TKnobsTextLabel;
    flangechorus_freezein: TKnobsInput;
    flangechorus_wet: TKnobsSmallKnob;
    flangechorus_rate: TKnobsSmallKnob;
    flangechorus_dry: TKnobsSmallKnob;
    flangechorus_sweep: TKnobsSmallKnob;
    flangechorus_feedback: TKnobsSmallKnob;
    flangechorus_freeze: TKnobsSelector;
    flangechorus_mute: TKnobsSelector;
    flangechorus_delay: TKnobsSmallKnob;
    pitchchange: TKnobsModule;
    pitchchange_editlabel: TKnobsEditLabel;
    pitchchange_in: TKnobsInput;
    pitchchange_textlabel_rate: TKnobsTextLabel;
    pitchchange_textlabel_feedback: TKnobsTextLabel;
    pitchchange_textlabel_wet: TKnobsTextLabel;
    pitchchange_textlabel_dry: TKnobsTextLabel;
    pitchchange_textlabel_depth: TKnobsTextLabel;
    pitchchange_out: TKnobsOutput;
    pitchchange_textlabel_delay: TKnobsTextLabel;
    pichchange_freezein: TKnobsInput;
    pitchchange_wet: TKnobsSmallKnob;
    pitchchange_rate: TKnobsSmallKnob;
    pitchchange_dry: TKnobsSmallKnob;
    pitchchange_depth: TKnobsSmallKnob;
    pitchchange_feedback: TKnobsSmallKnob;
    pitchchange_freeze: TKnobsSelector;
    pitchchange_mute: TKnobsSelector;
    pitchchange_delay: TKnobsSmallKnob;
    MemoFlangeChorus: TMemo;
    MemoPitchChange: TMemo;
    ImageCompressor: TImage;
    compressor: TKnobsModule;
    compressor_outl: TKnobsOutput;
    compressor_inl: TKnobsInput;
    compressor_editlabel: TKnobsEditLabel;
    compressor_textlabel_attack: TKnobsTextLabel;
    compressor_textlabel_decay: TKnobsTextLabel;
    compressor_textlabel_gain: TKnobsTextLabel;
    compressor_outr: TKnobsOutput;
    compressor_inr: TKnobsInput;
    compressor_textlabel_reflevel: TKnobsTextLabel;
    compressor_box_level: TKnobsBox;
    compressor_level: TKnobsIndicatorBar;
    compressor_textlabel_preamp: TKnobsTextLabel;
    compressor_textlabel_appliedgain: TKnobsTextLabel;
    compressor_release: TKnobsSmallKnob;
    compressor_display_attack: TKnobsDisplay;
    compressor_display_decay: TKnobsDisplay;
    compressor_gain: TKnobsSmallKnob;
    compressor_attack: TKnobsSmallKnob;
    compressor_reflevel: TKnobsSmallKnob;
    compressor_display_reflevel: TKnobsDisplay;
    compressor_bypass: TKnobsSelector;
    compressor_display_gain: TKnobsDisplay;
    compressor_display_preamp: TKnobsDisplay;
    compressor_preamp: TKnobsSmallKnob;
    MemoCompressor: TMemo;
    ImageWavePlayer: TImage;
    waveplayer: TKnobsModule;
    waveplayer_editlabel: TKnobsEditLabel;
    waveplayer_out: TKnobsOutput;
    waveplayer_speed: TKnobsInput;
    waveplayer_textlabel_speed: TKnobsTextLabel;
    waveplayer_textlabel_duration: TKnobsTextLabel;
    waveplayer_textlabel_position: TKnobsTextLabel;
    waveplayer_position: TKnobsInput;
    waveplayer_symbol_res: TImage;
    waveplayer_res: TKnobsInput;
    waveplayer_indicator_res: TKnobsIndicator;
    waveplayer_textlabel_res: TKnobsTextLabel;
    waveplayer_outr: TKnobsOutput;
    waveplayer_textlabel_l: TKnobsTextLabel;
    waveplayer_textlabel_r: TKnobsTextLabel;
    waveplayer_fm: TKnobsInput;
    waveplayer_textlabel_fm: TKnobsTextLabel;
    waveplayer_display_duration: TKnobsDisplay;
    waveplayer_fileselector_filename: TKnobsFileSelector;
    waveplayer_mode: TKnobsSelector;
    waveplayer_display_mono: TKnobsDisplay;
    MemoWavePlayer: TMemo;
    freqshifter: TKnobsModule;
    freqshifter_up: TKnobsOutput;
    freqshifter_down: TKnobsOutput;
    freqshifter_in: TKnobsInput;
    freqshifter_editlabel: TKnobsEditLabel;
    freqshifter_textlabel_in: TKnobsTextLabel;
    freqshifter_textlabel_up: TKnobsTextLabel;
    freqshifter_textlabel_dn: TKnobsTextLabel;
    freqshifter_shift: TKnobsSmallKnob;
    freqshifter_display_shift: TKnobsDisplay;
    freqshifter_shiftdepth: TKnobsSmallKnob;
    freqshifter_shiftmod: TKnobsInput;
    freqshifter_textlabel_mod: TKnobsTextLabel;
    freqshifter_textlabel_shift: TKnobsTextLabel;
    median: TKnobsModule;
    median_editlabel: TKnobsEditLabel;
    median_symbol_trig: TImage;
    median_out: TKnobsOutput;
    median_in: TKnobsInput;
    median_trig: TKnobsInput;
    median_indicator_trig: TKnobsIndicator;
    median_textlabel_in: TKnobsTextLabel;
    median_textlabel_trig: TKnobsTextLabel;
    ImageMedian: TImage;
    MemoMedian: TMemo;
    median_binsize: TKnobsSmallKnob;
    median_display_binsize: TKnobsDisplay;
    median_textlabel_binsize: TKnobsTextLabel;
    ImageFreqShifter: TImage;
    MemoFreqShifter: TMemo;
    resonator_fm: TKnobsInput;
    resonator_textlabel_fm: TKnobsTextLabel;
    resonator_fmlevel: TKnobsSmallKnob;
    resonator_display_frequency: TKnobsDisplay;
    resonator_frequency: TKnobsSmallKnob;
    resonator_cents: TKnobsSmallKnob;
    resonator_display_cents: TKnobsDisplay;
    resonator_pm: TKnobsInput;
    resonator_textlabel_pm: TKnobsTextLabel;
    resonator_pmlevel: TKnobsSmallKnob;
    resonator_dm: TKnobsInput;
    resonator_textlabel_dm: TKnobsTextLabel;
    resonator_dmlevel: TKnobsSmallKnob;
    resonator_click: TKnobsSmallKnob;
    resonator_textlabel_click: TKnobsTextLabel;
    crap_tabsheet: TTabSheet;
    zerocounter: TKnobsModule;
    zerocounter_editlabel: TKnobsEditLabel;
    zerocounter_note: TKnobsOutput;
    zerocounter_textlabel_threshold: TKnobsTextLabel;
    zerocounter_in: TKnobsInput;
    zerocounter_textlabel_in: TKnobsTextLabel;
    zerocounter_gate: TKnobsOutput;
    zerocounter_indicator_gate: TKnobsIndicator;
    zerocounter_period: TKnobsOutput;
    zerocounter_textlabel_period: TKnobsTextLabel;
    zerocounter_textlabel_gate: TKnobsTextLabel;
    zerocounter_textlabel_note: TKnobsTextLabel;
    zerocounter_threshold: TKnobsSmallKnob;
    zerocounter_display_threshold: TKnobsDisplay;
    ImageZeroCounter: TImage;
    MemoZeroCounter: TMemo;
    seqrandom_distmodamt: TKnobsSmallKnob;
    seqrandom_dist: TKnobsSmallKnob;
    seqrandom_distmod: TKnobsInput;
    seqrandom_textlabel_rnddistribution: TKnobsTextLabel;
    noiselfo_colormodamt: TKnobsSmallKnob;
    noiselfo_colormod: TKnobsInput;
    noiselfo_textlabel_colormod: TKnobsTextLabel;
    noise_colormodamt: TKnobsSmallKnob;
    noise_colormod: TKnobsInput;
    noise_textlabel_colormod: TKnobsTextLabel;
    randsig_dist: TKnobsSmallKnob;
    randsig_distmodamt: TKnobsSmallKnob;
    randsig_distmod: TKnobsInput;
    randsig_textlabel_distribution: TKnobsTextLabel;
    noiselfotrig_colormodamt: TKnobsSmallKnob;
    noiselfotrig_colormod: TKnobsInput;
    noisetrig_colormodamt: TKnobsSmallKnob;
    noisetrig_colormod: TKnobsInput;
    noisetrig_textlabel_colormod: TKnobsTextLabel;
    randomwalklfo_colormodamt: TKnobsSmallKnob;
    randomwalklfo_colormod: TKnobsInput;
    avg_alphamodamt: TKnobsSmallKnob;
    avg_alphamod: TKnobsInput;
    phasedetect: TKnobsModule;
    phasedetect_editlabel: TKnobsEditLabel;
    phasedetect_out: TKnobsOutput;
    phasedetect_in1: TKnobsInput;
    phasedetect_in2: TKnobsInput;
    phasedetect_indicator_up: TKnobsIndicator;
    MemoPhaseDetect: TMemo;
    ImagePhaseDetect: TImage;
    phasedetect_indicator_lock: TKnobsIndicator;
    phasedetect_textlabel_sigin: TKnobsTextLabel;
    phasedetect_textlabel_cmpin: TKnobsTextLabel;
    phasedetect_textlabel_filterout: TKnobsTextLabel;
    phasedetect_indicator_down: TKnobsIndicator;
    phasedetect_alpha: TKnobsSmallKnob;
    phasedetect_alphamodamt: TKnobsSmallKnob;
    phasedetect_alphamod: TKnobsInput;
    phasedetect_textlabel_filter: TKnobsTextLabel;
    phasedetect_lock: TKnobsOutput;
    phasedetect_textlabel_lock: TKnobsTextLabel;
    phasedetect_type: TKnobsSelector;
    phasedetect_typesel: TKnobsInput;
    morse: TKnobsModule;
    morse_editlabel: TKnobsEditLabel;
    morse_out: TKnobsOutput;
    morse_clock: TKnobsInput;
    morse_reset: TKnobsInput;
    morse_indicator_clock: TKnobsIndicator;
    morse_indicator_reset: TKnobsIndicator;
    morse_textlabel_clock: TKnobsTextLabel;
    morse_textlabel_res: TKnobsTextLabel;
    morse_display_text: TKnobsDisplay;
    morse_indicator_out: TKnobsIndicator;
    ImageMorse: TImage;
    MemoMorse: TMemo;
    xyscope: TKnobsModule;
    xyscope_editlabel: TKnobsEditLabel;
    xyscope_viewer: TKnobsDataViewer;
    xyscope_inx: TKnobsInput;
    xyscope_textlabel_x: TKnobsTextLabel;
    xyscope_levx: TKnobsSmallKnob;
    xyscope_iny: TKnobsInput;
    xyscope_textlabel_y: TKnobsTextLabel;
    xyscope_levy: TKnobsSmallKnob;
    xyscope_history: TKnobsSmallKnob;
    xyscope_display_history: TKnobsDisplay;
    xyscope_textlabel_history: TKnobsTextLabel;
    xyscope_lockxy: TKnobsSelector;
    xyscope_textlabel_lockxy: TKnobsTextLabel;
    ImageXYScope: TImage;
    MemoXYScope: TMemo;
    compare: TKnobsModule;
    compare_editlabel: TKnobsEditLabel;
    compare_outless: TKnobsOutput;
    compare_outmore: TKnobsOutput;
    compare_in1: TKnobsInput;
    compare_in2: TKnobsInput;
    compare_textlabel_ins: TKnobsTextLabel;
    compare_outequal: TKnobsOutput;
    compare_textlabel_less: TKnobsTextLabel;
    compare_textlabel_more: TKnobsTextLabel;
    compare_textlabel_equal: TKnobsTextLabel;
    compare_indicator_more: TKnobsIndicator;
    compare_indicator_equal: TKnobsIndicator;
    compare_indicator_less: TKnobsIndicator;
    ImageCompare: TImage;
    MemoCompare: TMemo;
    mux: TKnobsModule;
    mux_editlabel: TKnobsEditLabel;
    mux_in0: TKnobsInput;
    mux_control: TKnobsInput;
    mux_indicator_0: TKnobsIndicator;
    mux_in1: TKnobsInput;
    mux_in2: TKnobsInput;
    mux_in3: TKnobsInput;
    mux_in4: TKnobsInput;
    mux_in5: TKnobsInput;
    mux_in6: TKnobsInput;
    mux_in7: TKnobsInput;
    mux_in8: TKnobsInput;
    mux_in9: TKnobsInput;
    mux_in10: TKnobsInput;
    mux_out: TKnobsOutput;
    mux_in11: TKnobsInput;
    mux_texxtlabel_control: TKnobsTextLabel;
    mux_indicator_1: TKnobsIndicator;
    mux_indicator_2: TKnobsIndicator;
    mux_indicator_3: TKnobsIndicator;
    mux_indicator_4: TKnobsIndicator;
    mux_indicator_5: TKnobsIndicator;
    mux_indicator_6: TKnobsIndicator;
    mux_indicator_7: TKnobsIndicator;
    mux_indicator_8: TKnobsIndicator;
    mux_indicator_9: TKnobsIndicator;
    mux_indicator_10: TKnobsIndicator;
    mux_indicator_11: TKnobsIndicator;
    mux_xfade: TKnobsSmallKnob;
    mux_texxtlabel_crossfade: TKnobsTextLabel;
    ImageMux: TImage;
    MemoMux: TMemo;
    demux: TKnobsModule;
    demux_editlabel: TKnobsEditLabel;
    demux_control: TKnobsInput;
    demux_in: TKnobsInput;
    demux_out0: TKnobsOutput;
    demux_out1: TKnobsOutput;
    demux_out2: TKnobsOutput;
    demux_out3: TKnobsOutput;
    demux_out4: TKnobsOutput;
    demux_out5: TKnobsOutput;
    demux_out6: TKnobsOutput;
    demux_out7: TKnobsOutput;
    demux_out8: TKnobsOutput;
    demux_out9: TKnobsOutput;
    demux_out10: TKnobsOutput;
    demux_out11: TKnobsOutput;
    demux_indicator_0: TKnobsIndicator;
    demux_textlabel_control: TKnobsTextLabel;
    demux_indicator_1: TKnobsIndicator;
    demux_indicator_2: TKnobsIndicator;
    demux_indicator_3: TKnobsIndicator;
    demux_indicator_4: TKnobsIndicator;
    demux_indicator_5: TKnobsIndicator;
    demux_indicator_6: TKnobsIndicator;
    demux_indicator_7: TKnobsIndicator;
    demux_indicator_8: TKnobsIndicator;
    demux_indicator_9: TKnobsIndicator;
    demux_indicator_10: TKnobsIndicator;
    demux_indicator_11: TKnobsIndicator;
    demux_textlabel_xfade: TKnobsTextLabel;
    demux_xfade: TKnobsSmallKnob;
    ImageDemux: TImage;
    MemoDemux: TMemo;
    ImageScala: TImage;
    scala: TKnobsModule;
    scala_editlabel: TKnobsEditLabel;
    scala_out: TKnobsOutput;
    scala_in: TKnobsInput;
    scala_textlabel_in: TKnobsTextLabel;
    MemoScala: TMemo;
    scala_fileselector_mapping: TKnobsFileSelector;
    scala_fileselector_scale: TKnobsFileSelector;
    hardclip: TKnobsModule;
    hardclip_editlabel: TKnobsEditLabel;
    hardclip_out: TKnobsOutput;
    hardclip_in: TKnobsInput;
    hardclip_textlabel_in: TKnobsTextLabel;
    hardclip_textlabel_highlevel: TKnobsTextLabel;
    hardclip_highlevel: TKnobsSmallKnob;
    hardclip_display_highlevel: TKnobsDisplay;
    hardclip_mute: TKnobsSelector;
    ImageHardClip: TImage;
    MemoHardClip: TMemo;
    hardclip_textlabel_lowlevel: TKnobsTextLabel;
    hardclip_lowlevel: TKnobsSmallKnob;
    hardclip_display_lowlevel: TKnobsDisplay;
    hardclip_textlabel_outamp: TKnobsTextLabel;
    hardclip_outamp: TKnobsSmallKnob;
    hardclip_display_outamp: TKnobsDisplay;
    compare_range: TKnobsSmallKnob;
    compare_display_range: TKnobsDisplay;
    compare_textlabel_range: TKnobsTextLabel;
    KnobsTextLabel1: TKnobsTextLabel;
    hardclip_lock: TKnobsSelector;
    textsequencer_gateout: TKnobsOutput;
    textsequencer_textlabel_gate: TKnobsTextLabel;
    textsequencer_indicator_gate: TKnobsIndicator;
    seqrandom_chain: TKnobsInput;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FModules       : TKnobsModuleList;
    FOnDesignerLog : TOnDesignerLog;
  private
    procedure   DoModuleListLog( const aSender: TObject; const aMsg: string);
    procedure   DoModuleLog    ( const aSender: TObject; const aMsg: string);
    procedure   RegisterModules;
    procedure   Log( const aMsg: string);
    procedure   LogFmt( const aFmt: string; const anArgs: array of const);
  public
    function    CreateModule(
      const aWirePanel  : TKnobsWirePanel;
      const aModuleType : TKnobsModuleType;
      MustDrag          : Boolean
    ): TKnobsCustomModule;

    procedure   PopulateSelector  ( const aModuleSelector: TKnobsModuleSelector);
    procedure   ShowModule        ( const aModule: TKnobsCustomModule);
    function    CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    function    ReadModuleComment ( const aModuleType: TKnobsModuleType): string;
    procedure   MakeImage         ( const aFolder: string; const aModule: TKnobsCustomModule);
    procedure   MakeImages        ( const aFolder: string);
    function    FindBitmap        ( const aModuleTitle: string): TBitmap;
    function    FindDocu          ( const aModuleTitle: string): TStrings;
    function    DocumentModule    ( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    function    MakeDocIndex      : string;
    function    MakeDocHeader     ( const aVersion: string): string;
    function    MakeDocFooter     : string;
    function    DoDocument        ( const aFolder, anImagesFolder, aVersion: string): string;
    procedure   Document          ( const aFolder, anImagesFolder, aVersion: string);
  public
    property    Modules       : TKnobsModuleList read FModules;
    property    OnDesignerLog : TOnDesignerLog   read FOnDesignerLog write FOnDesignerLog;
  end;


var

  FormStore: TFormStore;


implementation


{$R *.DFM}


// User area


//  private


    // -------------------------------------------------------------------------

    procedure   TFormStore.DoModuleListLog( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'ModuleList (%s)', [ aMsg]);
    end;

    procedure   TFormStore.DoModuleLog( const aSender: TObject; const aMsg: string);
    begin
      LogFmt( 'Module (%s)', [ aMsg]);
    end;

    procedure   TFormStore.RegisterModules;
    var
      i : Integer;
    begin
      FModules := TKnobsModuleList.Create;

      FModules.OnLog := DoModuleListLog;

      for i := 0 to ComponentCount - 1
      do begin
        if ( Components[ i] is TKnobsCustomModule)
        then begin
          TKnobsCustomModule( Components[ i]).FixDisplays;
          TKnobsCustomModule( Components[ i]).OnLog := DoModuleLog;
          FModules.Add( Components[ i]);
        end;
      end;

      FModules.RegisterComponents( True);
    end;

    procedure   TFormStore.Log( const aMsg: string);
    begin
      if Assigned( FOnDesignerLog)
      then FOnDesignerLog( Self, Format( 'designer (%s)', [ aMsg]));
    end;

    procedure   TFormStore.LogFmt( const aFmt: string; const anArgs: array of const);
    begin
      Log( Format( aFmt, anArgs));
    end;


//  public


    function    TFormStore.CreateModule(
      const aWirePanel  : TKnobsWirePanel;
      const aModuleType : TKnobsModuleType;
      MustDrag          : Boolean
    ): TKnobsCustomModule;
    begin
      Result := FModules.CreateModule( aWirePanel, aModuleType, MustDrag);
      if Assigned( Result) and Assigned( aWirePanel)
      then Result.ControlMode := aWirePanel.ControlMode;
    end;


    procedure   TFormStore.PopulateSelector( const aModuleSelector: TKnobsModuleSelector);
    begin
      FModules.PopulateSelector( aModuleSelector);
    end;

    procedure   TFormStore.ShowModule( const aModule: TKnobsCustomModule);
    var
      aTabSheet: TTabSheet;
    begin
      aTabSheet := aModule.Parent as TTabSheet;
      savedstuff_pagecontrol.ActivePage := aTabSheet;
    end;

    function    TFormStore.CreateModuleBitmap( const aModuleType: TKnobsModuleType): TBitmap;
    var
      i : Integer;
    begin
      Result := nil;
      if Assigned( FModules)
      then begin
        for i := 0 to FModules.Count - 1
        do begin
          if FModules[ i].ModuleType = aModuleType
          then begin
            Result := FModules[ i].AsBitmap;
            Break;
          end;
        end;
      end;
    end;

    function    TFormStore.ReadModuleComment( const aModuleType: TKnobsModuleType): string;
    var
      i : Integer;
    begin
      Result := '';
      if Assigned( FModules)
      then begin
        for i := 0 to FModules.Count - 1
        do begin
          if FModules[ i].ModuleType = aModuleType
          then begin
            Result := FModules[ i].Comment;
            if Result = ''
            then Result := FModules[ i].Title;
            Break;
          end;
        end;
      end;
    end;

    procedure   TFormStore.MakeImage( const aFolder: string; const aModule: TKnobsCustomModule);
    var
      aBitmap   : TBitmap;
      aFileName : string;
      aJPeg     : TJPEGImage;
    begin
      if Assigned( aModule)
      then begin
        aFileName := aFolder + '\TMod' + aModule.Title + '.jpg';
        aBitmap := aModule.AsBitmap;
        try
          aJpeg := TJPEGImage.Create;
          try
            aJpeg.CompressionQuality  := 90;
            aJpeg.ProgressiveEncoding := True;
            aJpeg.Assign( aBitmap);
            aJpeg.Compress;
            aJpeg.SaveToFile( aFileName);
          finally
            FreeAndNil( aJpeg);
          end;
        finally
          aBitmap.Free;
        end;
      end;
    end;

    procedure   TFormStore.MakeImages( const aFolder: string);
    var
      i : Integer;
    begin
      for i := 0 to FModules.Count - 1
      do begin
        ShowModule( FModules[ i]);
        MakeImage( aFolder, FModules[ i]);
      end;
    end;

    function    TFormStore.FindBitmap( const aModuleTitle: string): TBitmap;
    var
      i      : Integer;
      anImage: TImage;
    begin
      Result := nil;
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TImage
        then begin
          anImage := TImage( Components[ i]);
          if SameText( anImage.Name, Format( 'Image%s', [ aModuleTitle]))
          then Result := anImage.Picture.Bitmap;
        end;
      end;
    end;


    function    TFormStore.FindDocu( const aModuleTitle: string): TStrings;
    var
      i     : Integer;
      aMemo : TMemo;
    begin
      Result := nil;
      for i := 0 to ComponentCount - 1
      do begin
        if Components[ i] is TMemo
        then begin
          aMemo := TMemo( Components[ i]);
          if SameText( aMemo.Name, Format( 'Memo%s', [ aModuleTitle]))
          then Result := aMemo.Lines;
        end;
      end;
    end;

    function    TFormStore.DocumentModule( const aModule: TKnobsCustomModule; const anImagesFolder: string; anIndex: Integer): string;
    var
      aDocu : TStrings;
      i     : Integer;
      First : Boolean;
      aType : Integer;
    begin
      Result := '';
      if Assigned( aModule)
      then begin
        aDocu := FindDocu( aModule.Title);
        if Assigned( aDocu)
        then begin
          First := True;
          for i := 0 to aDocu.Count - 1
          do begin
            if aDocu[ i] <> ''
            then begin
              if First
              then begin
                First  := False;
                aType  := aModule.ModuleType;
                Result := Result + '<a href=''#index''>index</a>';
                Result := Result + Format( '<h2><a id=''%d'' name=''%d''>%d %s</a></h2>'^M, [ aType, aType, anIndex, aDocu[ i]]);
                Result := Result + Format( '<h3>Page: %s</h3>'^M                          , [ aModule.PageName                ]);
                Result := Result + Format( '<img src=''./images/TMod%s.jpg''>'^M          , [ aModule.Title                   ]);
                Result := Result + Format( '<p>Type: %d'^M                                , [ aType                           ]);
              end
              else Result := Result + Format( '%s'^M  , [ aDocu[ i]]);
            end
            else begin
              if not First
              then Result := Result + ^M + '<p>';
            end;
          end;
          Result := Result + ^M + '<hr>'^M;
        end;
      end;
    end;

    function    TFormStore.MakeDocIndex: string;
    const
      Header    = '<tr><th>#</th><th>Page</th><th>Module type</th><th>Looks</th></tr>'^M;
      Separator = '<tr><th colspan=''4''><hr></th></tr>'^M;
    var
      i         : Integer;
      anIndex   : Integer;
      aPage     : string;
      anOldPage : string;
      aModule   : string;
      aType     : Integer;
    begin
      anOldPage := '';
      Result    := '';
      Result    := Result + '<table>'^M'<tbody>'^M;
      Result    := Result + Header;
      anIndex   := 1;
      for i := 0 to FModules.Count - 1
      do begin
        with Modules[ i]
        do begin
          aType := ModuleType;
          if aType >= 0
          then begin
            aPage     := PageName;
            aModule   := Title;
            if not SameText( anOldPage, aPage)
            then Result := Result + Separator;
            Result    := Result + Format( '<tr><td>%d</td><td>%s</td><td><a href=''#%d''>%s</a></td><td><a href=''#%d''><img src=''./images/TMod%s.jpg''></a></td></tr>', [ anIndex, aPage, aType, aModule, aType, aModule]);
            anOldPage := aPage;
            Inc( anIndex);
          end;
        end;
      end;
      Result := Result + '</tbody>'^M'</table>'^M;
    end;

    function    TFormStore.MakeDocHeader( const aVersion: string): string;
    begin
      Result := '';
      Result := Result + '<!doctype html>'^M'<html>'^M'<head>'^M'<title>WREN module documentation</title>'^M'</head>'^M;
      Result := Result + '<h1><a name=''index'' id=''index''>WREN module documentation</a></h1>'^M;
      Result := Result + Format( '<h3>Version : %s</h3>'^M, [ aVersion]);
      Result := Result + '<p> COPYRIGHT 1999 - 2014 Blue Hell</p>';
      Result := Result + '<p> COPYRIGHT 2014 HrastProgrammer</p>';
      Result := Result + '<p>Look <a href=''http://bluehell.electro-music.com/modules/''>here</a> for more information.</p>'^M;
      Result := Result + MakeDocIndex;
      Result := Result + '<hr>';
    end;

    function    TFormStore.MakeDocFooter: string;
    begin
      Result := '';
      Result := Result + '<p> COPYRIGHT 1999 - 2014 Blue Hell</p>';
      Result := Result + '<p> COPYRIGHT 2014 HrastProgrammer</p>';
      Result := Result + '<p>Look <a href=''http://bluehell.electro-music.com/modules/''>here</a> for more information.</p>'^M;
      Result := Result + '<p>~~ fin ~~</p>';
      Result := Result + '</body>'^M'</html>';
    end;

    function    TFormStore.DoDocument( const aFolder, anImagesFolder, aVersion: string): string; // overload;
    var
      i       : Integer;
      anIndex : Integer;
    begin
      Result  := MakeDocHeader( aVersion);
      anIndex := 1;
      for i := 0 to FModules.Count - 1
      do begin
        if FModules[ i].ModuleType >= 0
        then begin
          ShowModule( FModules[ i]);
          MakeImage( aFolder + anImagesFolder, FModules[ i]);
          Result := Result + DocumentModule( FModules[ i], anImagesFolder, anIndex);
          Inc( anIndex);
        end;
      end;
      Result := Result + MakeDocFooter;
    end;

    procedure   TFormStore.Document( const aFolder, anImagesFolder, aVersion: string); // overload;
    var
      aFileName : string;
      aFile     : TextFile;
      Data      : string;
    begin
      Data := '';
      aFileName := aFolder + '\modules.html';
      AssignFile( aFile, aFileName);
      try
        Rewrite( aFile);
        Write( aFile, DoDocument( aFolder, anImagesFolder, aVersion));
      finally
        CloseFile( aFile);
      end;
    end;


// Delphi area



procedure TFormStore.FormCreate(Sender: TObject);
begin
  FModules := nil;
  RegisterModules;
  notes_tabsheet.TabVisible := False;
end;


procedure TFormStore.FormDestroy(Sender: TObject);
begin
  if Assigned( FModules)
  then begin
    FModules.RegisterComponents( False);
    FModules.Free;
  end;
end;

end.
